#!/usr/bin/perl

##########################################################################
$main_dir = "."; # cgi ִ° 丮  
$main_url = ".";				 #spboard 丮 ִ° URL
$cgi_url = "./board.cgi";        # cgi URL
$img_url = "./img";              #img URL
$sendmail = "/usr/lib/sendmail"; #sendmail ġ
$NT = "0";                       #ڵ    $NT="1"...  
##########################################################################

&parseArgument;

sub parseArgument {
    local($pair,$name,$value,$content_type,$content_length,$buffer,$dump,$boundary,$line,$array_value);
    local(@pairs,@column);

    if($ENV{'QUERY_STRING'}) {
    @pairs = split(/&/,$ENV{'QUERY_STRING'});

        foreach $pair (@pairs) {
            ($name, $value) = split(/=/,$pair);

            $value =~ tr/+/ /;
            $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
			$value =~ s/\|/&#124;/g;
            $FORM{$name} = $value;
        } 
    }
    else {
        $content_type = $ENV{'CONTENT_TYPE'};
        $content_length = $ENV{'CONTENT_LENGTH'};

        binmode STDIN;
        read(STDIN,$buffer,$content_length);
 
        if((!$content_type) ||
           ($content_type eq 'application/x-www-form-urlencoded')) {
            @pairs = split(/&/, $buffer);

            foreach $pair (@pairs)  {
                ($name, $value) = split(/=/,$pair);
                $value =~ tr/+/ /;
                $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
		 		$value =~ s/\|/&#124;/g;
                $FORM{$name} = $value;
            }
        }
        elsif($content_type =~ m#^multipart/form-data#) {
            ($boundary = $content_type) =~ s/^.*boundary=(.*)$/\1/;
            @pairs = split(/--$boundary/, $buffer);
            @pairs = splice(@pairs,1,$#pairs-1);

            for $pair (@pairs)  {
                ($dump,$line,$value) = split(/\r\n/,$pair,3);
                if($line =~ /filename/) {
	            $real_file = $line;
                }

                next if $line =~ /filename=\"\"/;
                $line =~ s/^Content-Disposition: form-data; //;
                (@column) = split(/;\s+/, $line);
                ($name = $column[0]) =~ s/^name="([^"]+)"$/\1/g;
 
                if($#column > 0) { 
                    if($value =~ /^Content-Type:/)  {
                        ($dump,$dump,$value) = split(/\r\n/,$value,3);
                    }
                    else {
                        ($dump,$value) = split(/\r\n/,$value,2);
                    }
                }
                else {
                    ($dump,$value) = split(/\r\n/,$value,2);
                    if(grep(/^$name$/, keys(%CGI))) {
                        if(@{$FORM{$name}} > 0) {
                            push(@{$FORM{$name}}, $value);
                        }
                        else { 
                            $array_value = $FORM{$name};
                            undef $FORM{$name};
                            $FORM{$name}[0] = $array_value;
                            push(@{$FORM{$name}}, $value);
                        }
                    }
                    else {
                        next if $value =~ /^\s*$/;
                        $FORM{$name} = $value;
                        chop($FORM{$name});
	                chop($FORM{$name});
                    }
                    next;
                }
                $FORM{$name} = $value;
            }
        }
        else {
            print "Invalid content type!\n";
            exit(1);
        }
    }

	$main_dir = "$main_dir/$FORM{'id'}";
	$main_url = "$main_url/$FORM{'id'}";
	&selectAction;
}

sub selectAction {

	if($FORM{'page'} eq ""){
		$page = 1; 
	}
	else {
		$page= $FORM{'page'};
	}

	if($FORM{'id'}) {
		&get_env;
		
		if($FORM{'action'} eq "") {
			&display;
		}
		elsif($FORM{'action'} eq "form") {
			&input_form;
		}
		elsif($FORM{'action'} eq "write") {
			if(($FORM{'name'} eq "") || ($FORM{'comments'} eq "")||($FORM{'subject'} eq "")){
				&error;
			}
			else {	&write;	}
		}
		elsif($FORM{'action'} eq "adminwrite") {
			&adminwrite;
		}
		elsif($FORM{'action'} eq "view") {
			&view;
		}
		elsif($FORM{'action'} eq "reply") {
			&reply_form;
		}
		elsif($FORM{'action'} eq "down") {
			&down_file;
		}
		elsif($FORM{'action'} eq "admin_login") {
			&admin_login;
		}
		elsif($FORM{'action'} eq "loginok") {
			$pass = crypt($FORM{'passwd'},sp);
			if(($pass eq "") || ($pass ne $admin)) {
				$err = pass;
				&error;
			}
			&loginok;
		}
		elsif($FORM{'action'} eq "view_notice"){
			&view_notice;
		}
		elsif($FORM{'action'} eq "modify"){
			&enterpass;
		}
		elsif($FORM{'action'} eq "admin_modify"){
			&admin_ok;
		} 
		elsif($FORM{'action'} eq "admin_remove"){
			&admin_remove;
		}
		elsif($FORM{'action'} eq "admin_act"){
			if($FORM{'admin_select'} eq "admin_conf"){ 
				&admin_conf;
			}
			elsif($FORM{'admin_select'} eq "notice_form"){
				&notice_form;
			}
		}
		elsif($FORM{'action'} eq "admin_remove_ok"){
			$pass = crypt($FORM{'passwd'},sp);
			if(($admin ne $pass)||($pass eq "")) {
				$err = pass;
				&error;
			}
			elsif($admin eq $pass) {
				&admin_remove_ok;
			}
		}
		elsif($FORM{'action'} eq "passok"){
			&passok;
		}
		elsif($FORM{'action'} eq "modify_ok") {
			if(($FORM{'name'} eq "") || ($FORM{'comments'} eq "")|| ($FORM{'subject'} eq "")) {
				&error;
			}
			else { &modify;}
		}
		elsif($FORM{'action'} eq "admin_ok"){
			$pass = crypt($FORM{'passwd'},sp);
			if(($admin ne $pass)||($pass eq "")) {
				$err = pass;
				&error;
			}
			elsif($admin eq $pass){
				&admin_modify_form;
			}
		}
		elsif($FORM{'action'} eq "make_conf"){
			&make_conf;
		}
		elsif($FORM{'action'} eq "erase") {
			&erase;
		}
		elsif($FORM{'action'} eq "search") { 
			if($FORM{'keyword'} eq ""){
				$err = keyword;
				&error;
			}
			else{
				&search;
			}
		}
		elsif($FORM{'action'} eq "display"){
			&display;
		}
		elsif($FORM{'action'} eq "eraseok") {
			if($FORM{'passwd'} eq "") {
				$err = pass;
				&error;
			}
			&eraseok;
		}
		else {
			&display;
		}
	}
	else{ 
		$err = id;
		&error;
	}
}

sub get_env{

    if(open(CONF,"<$main_dir/conf.txt")) {
        @list = <CONF>;
        close(CONF);
        @env = split(/\|/,$list[0]);
		@quick = split(/\|/,$list[1]);
		@q_name = split(/\|/,$list[2]);
        $page_num = $env[1];
		$admin_only = $env[2];
        $max_data = $env[3];
        $admin = $env[4];
        $smail = $env[5];
        $admin_mail = $env[6];
		$home_url = $env[7];
        $width = $env[8];
        $admin_name = $env[9];
        $ncel_color = $env[10];
        $head_color = $env[11];
		$cel_color1 = $env[12];
		$select_color = $env[13];
        $num_color = $env[14];
        $date_color = $env[15];
        $read_color = $env[16];
		$bgcolor = $env[17];
		$background = $env[18];
		$logo_img = $env[19];
		$logo_txt = $env[20];
		$sub_length = $env[21];
		$cel_color2 = $env[22];
		$line_length = $env[23];
		$view_ip = $env[24];
		$pds_ok = $env[25];
		$max_size = $env[26];
		$down_view = $env[27];
		$kind_view = $env[28];
		$quick1 = $quick[1];
		$quick2 = $quick[2];
		$quick3 = $quick[3];
		$quick4 = $quick[4];
		$quick5 = $quick[5];
		$quick6 = $quick[6];
		$quick7 = $quick[7];
		$q_name1 = $q_name[1];
		$q_name2 = $q_name[2];
		$q_name3 = $q_name[3];
		$q_name4 = $q_name[4];
		$q_name5 = $q_name[5];
		$q_name6 = $q_name[6];
		$q_name7 = $q_name[7];
	}
    else {
        mkdir("$main_dir/files",0777);
		chmod(0777,"$main_dir/files");
		$page_num = "10";
		$admin_only = "no";
        $max_data = "5000";
        $admin = "1234";
        $smail = "yes";
        $admin_mail = "your\@email.net";
		$home_url = "http://yourhome.net";
        $width = "80%";
        $admin_name = "";
        $ncel_color = "#CDE2FF";
        $head_color = "#3A92FF";
		$cel_color1 = "#F4F9FF";
		$select_color= "#E9FFF0";
        $num_color = "#1504B9";
        $date_color = "#FF2BA1";
        $read_color = "#007025";
		$bgcolor = "#ffffff";
		$background = "";
		$logo_img = "";
		$logo_txt = "Ȱ¦~  Խ ^.^";
		$sub_length = "47";
		$cel_color2 = "#FCFEFF";
		$line_length = "1";
		$view_ip = "yes";
		$pds_ok = "no";
		$max_size = "4.5";
		$down_view = "no";
		$kind_view = "yes";
		$quick1 = "";
		$quick2 = "";
		$quick3 = "";
		$quick4 = "";
		$quick5 = "";
		$quick6 = "";
		$quick7 = "";
		$q_name1 = "";
		$q_name2 = "";
		$q_name3 = "";
		$q_name4 = "";
		$q_name5 = "";
		$q_name6 = "";
		$q_name7 = "";

		&save_env;
	}
}

sub save_env { 
	$admin = crypt($admin,sp);
	open(CONF,">$main_dir/conf.txt");
        print CONF "|$page_num|$admin_only|$max_data|$admin|$smail|$admin_mail|$home_url|$width|$admin_name|$ncel_color|$head_color|$cel_color1|$select_color|$num_color|$date_color|$read_color|$bgcolor|$background|$logo_img|$logo_txt|$sub_length|$cel_color2|$line_length|$view_ip|$pds_ok|$max_size|$down_view|$kind_view|\n";
		print CONF "|$quick1|$quick2|$quick3|$quick4|$quick5|$quick6|$quick7|\n";
		print CONF "|$q_name1|$q_name2|$q_name3|$q_name4|$q_name5|$q_name6|$q_name7|\n";
	close(CONF);
}

sub display {
	if($down_view eq "yes"){
		$down_col="<td width=30 align=center><font size=-1 color=$cel_color1>ٿ</font></td>";
	}
	
	&gul_list;
	if($option ne "view_data"){
		&head;
	}
	if($FORM{'action'} eq "view"){
		for($i=0;$i<$list_num;$i++){
			if($FORM{'number'} eq $remain[$i]){
				$next_num = $remain[$i-1];
				$prev_num = $remain[$i+1];
			}
		}
		open(PREV, "$main_dir/$prev_num");
		@pdata = <PREV>;
		@pline = split(/\|/,$pdata[1]);
		if($FORM{'category'} eq ""){
			$prev_data = "<a href=$cgi_url?id=$FORM{'id'}&page=$page&action=view&number=$prev_num><font color=$head_color> $pline[3] - $pline[0]</font></a>";
		}
		else{
			$prev_data = "<a href=$cgi_url?id=$FORM{'id'}&page=$page&action=view&number=$prev_num&category=$FORM{'category'}&keyword=$FORM{'keyword'}><font color=$head_color> $pline[3] - $pline[0]</font></a>";
		}
		close (PREV);
	
		open(NEXT, "$main_dir/$next_num");
		@ndata = <NEXT>;
		@nline = split(/\|/,$ndata[1]);
		if($FORM{'category'} eq ""){
			$next_data = " <a href=$cgi_url?id=$FORM{'id'}&page=$page&action=view&number=$next_num><font color=$head_color> $nline[3] - $nline[0]</font></a>";
		}
		else{
			$next_data = " <a href=$cgi_url?id=$FORM{'id'}&page=$page&action=view&number=$next_num&category=$FORM{'category'}&keyword=$FORM{'keyword'}><font color=$head_color> $nline[3] - $nline[0]</font></a>";
		}
		close (NEXT);

		print "<table width=$width border=0 cellpadding=3 cellspacing=0><tr><td>\n";
		if($FORM{'number'} ne $remain[0]){
			print " &nbsp; &nbsp; $next_data<br>";
		}
		if($FORM{'number'} ne $remain[$list_num-1]){
			print " &nbsp; &nbsp; $prev_data";
		}
		print "</td></tr></table><br>";
	}
	if($FORM{'category'} eq ""){
		if($quick1 ne ""){
			print "<script language=\"javascript\">\n";
			print "function buildArray() {\n";
			print "var a = buildArray.arguments;\n";
			print "for (i=0; i<a.length; i++) {\n";
			print "this[i] = a[i];}\n";
			print "this.length = a.length;}\n";
			print "var list1 = new buildArray(\"\",\n";
			print "\"$cgi_url?id=$quick1\",\n";
			print "\"$cgi_url?id=$quick2\",\n";
			print "\"$cgi_url?id=$quick3\",\n";
			print "\"$cgi_url?id=$quick4\",\n";
			print "\"$cgi_url?id=$quick5\",\n";
			print "\"$cgi_url?id=$quick6\",\n";
			print "\"$cgi_url?id=$quick7\");\n";
			print "function go(which, num, win) {\n";
			print "n = which.selectedIndex;\n";
			print "if (n != 0) {var url = eval(\"list\" + num + \"[n]\")\n";
			print "if (win) {openWindow(url);}\n";
			print "else{location.href = url;}}}\n";
			print "</script>\n";
			print "<div align=center><table border=0 cellpadding=2 cellspacing=0 width=$width><tr><td align=right>\n";
			print "<form name=quick><select name=quick_sel onChange=\"go(this, 1, false)\">\n";
			print "<option>ٷΰ</option>\n";
			print "<option value=$quick1>$q_name1</option>\n";
			if ($quick2 ne""){print "<option value=$quick2>$q_name2</option>\n";}
			if($quick3 ne ""){print "<option value=$quick3>$q_name3</option>\n";}
			if ($quick4 ne ""){print "<option value=$quick4>$q_name4</option>\n";}
			if ($quick5 ne ""){print "<option value=$quick5>$q_name5</option>\n";}
			if ($quick6 ne ""){print "<option value=$quick6>$q_name6</option>\n";}
			if ($quick7 ne ""){print "<option value=$quick7>$q_name7</option>\n";}
			print "</select>\n";
			print "</td></tr></table></div>\n";
		}

		if($page eq 1) {
			$d = 0;
			$s = 0;
			print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=#000000 width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
			if($tot_pg <= 1) {
				print "<table width=$width cellspacing=0 cellpadding=1 border=0><tr><td width=160 align=left><a href=$cgi_url?id=$FORM{'id'}&action=form><img src=$img_url/write.gif border=0 alt=\" \"></a></td><td align=center><font size=1>Total <font color=red>$fil_data</font>articles [ <font color=green>$page</font>/<font color=blue>$tot_pg</font> page ]</font></td><td width=160 align=right><img src=$img_url/prev.gif border=0 alt=\" \"><img src=$img_url/next.gif border=0 alt=\" \"></td></tr></table>\n";
			}
			else {
				print "<table width=$width cellspacing=0 cellpadding=1 border=0><tr><td width=160 align=left><a href=$cgi_url?id=$FORM{'id'}&action=form><img src=$img_url/write.gif border=0 alt=\" \"></a></td><td align=center><font size=1>Total <font color=red>$fil_data</font>articles [ <font color=green>$page</font>/<font color=blue>$tot_pg</font> page ]</font></td><td width=160 align=right><img src=$img_url/prev.gif border=0 alt=\" \"><a href=$cgi_url?id=$FORM{'id'}&page=2><img src=$img_url/next.gif border=0 alt=\" \"></a></td></tr></table>\n";
			}
			print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=#000000 width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
			print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=$head_color width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
			if($kind_view ne "yes"){
				$up_td = "";
			}
			else{
				$up_td = "<td>&nbsp;</td>";
			}	
			print "<table width=$width border=0 cellpadding=$line_length cellspacing=0 bgcolor=$head_color><tr align=center><td align=left><font color=$cel_color1></font></td>$up_td<td align=center><font size=-1 color=$cel_color1>  </font></td><td align=center><font size=-1 color=$cel_color1>ۼ</font></td><td align=center width=100><font size=-1 color=$cel_color1>ۼϽ</font></td><td width=30 align=center><font size=-1 color=$cel_color1>ȸ</font></td>$down_col</tr>\n";

			&read_notice;

		foreach $num (@remain) {
			open(FILE,"<$main_dir/$num");
			@data = <FILE>;
			close (FILE);
			#-------------------------------------- [   ]---------------------------
			@down_data = split(/\|/,$data[5]);
			$file_name = "$down_data[5]";
			if($down_data[4] ne ""){
				@name_data = split(/\//,$down_data[4]);
				$n_num = @name_data - 1;
				if($name_data[$n_num] =~/\?/){
					@cgi = split(/\?/,"$name_data[$n_num]");
					$file_name = $cgi[1];
				}
				else{
					$file_name = "$name_data[$n_num]";
				}
				$f_name = "$down_data[4]";
				$file_size = "ũ";
			}
			else{
				$f_name = $file_name;
				$file_size = "$down_data[6]";
			}
			@file_type = split(/\./,$file_name);
			$type = $file_type[1];
			&file_icon;
			@unknown = split(/\./,$type);
			if($unknown[1] eq ""){
				$type = "unknown.gif";
			}
			if(($down_data[5] eq "") && ($down_data[4] eq "")) {
				$file_icon = "<img src=$img_url/type/text.gif border=0> ";
			}
			else{
				$file_icon = "<a href=\"$cgi_url?id=$FORM{'id'}&num=$num&action=down&file=$f_name\"><img src=$img_url/type/$type border=0 alt=\"$file_name($file_size) ٿޱ\"></a> ";
			}
			$down_num = $down_data[7];
			if($down_num eq ""){
				$down_num = "0";
			}
#------------------------------------------------------------------------------
			$d = ($d+1);
			$s++;
			$rotate = $d%2;
			if($rotate eq "0"){
				$tr_color=$cel_color2;
			}
			else{
				$tr_color=$cel_color1;
			}
			@list = split(/\|/, $data[1]);
			if($NT eq  "1"){
				if($list[1]) { 
					$mailto = "<a href=mailto:$list[1]>$list[0]</a>";
				}
				else {
					$mailto = $list[0];
				}   
			}
			else{
				if($list[1]) { 
					$mailto = "<a href=\"javascript:newin(350, 250, 'sendmail.cgi?name=$list[0]&mail=$list[1]&prog=$sendmail&home_url=$home_url','spmail')\">$list[0]</a>";
				}
				else {
					$mailto = $list[0];
				}   	
			}
			$rdate = substr($list[4],5,13);
			$old_date = substr($list[4],0,10);
			&getdate;
			$new_date = substr($date,0,10);
				
			if($old_date eq $new_date) {
				if($num =~/-/){
					$subject = "<img src=$img_url/newans.gif border=0>";	
				}
				else{
					$subject = "<img src=$img_url/newgul.gif border=0>";
				}
			} 
			else{ 
				if($num =~/-/){
					$subject = "<img src=$img_url/ans.gif border=0>";
				}
				else{
					$subject = "<img src=$img_url/gul.gif border=0>";
				}
			} 
			@push = split(/-/,$num);
			shift(@push);
			$x_num = @push;
#=================================[  üũ ]===================================================
			$gul_len = length($list[3]);
			if($gul_len > $sub_length){
				for( $k = 0; $k < $sub_length; ){
					if( ord(substr($list[3], $k, 1)) >= 128 ){
						$k+=2;
					}
					else{
						$k++;
					}
					last  if( $k >= $sub_length-$x_num*3 );
				}
				$list[3] = substr($list[3],0,($k));
				$list[3] = $list[3]."..."; 
			}
#======================================================================================================
			$x_num *=17;
			if($kind_view ne "yes"){
				$icon_td = "";
			}
			else{
				$icon_td = "<td width=16 align=center>$file_icon</td>";
			}
			if($down_view eq "yes"){
				$num_col = "<td align=center><font size=-1 color=blue><b>$down_num</b></font></td>";
			}
			if(($num eq $FORM{'number'}) && ($FORM{'action'} ne "modify_ok")){
				print "<tr bgcolor=$select_color><td><font color=$num_color size=-1>$list_num</td>$icon_td<td><img src=$img_url/zero.gif height=10 width=$x_num>$subject <u><b>$list[3]</b></u></font></td><td align=center><font size=-1>$mailto</font></td><td align=center width=100><font size=-1 color=$date_color>$rdate</font></td><td align=center><font size=-1 color=$read_color>$list[5]</font></td>$num_col</tr>\n";
			}
			else{
				print "<tr bgcolor=$tr_color><td><font color=$num_color size=-1>$list_num</td>$icon_td<td><img src=$img_url/zero.gif height=10 width=$x_num><a href=$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}&action=view&number=$num>$subject $list[3]</a></font></td><td align=center><font size=-1>$mailto</font></td><td align=center width=100><font size=-1 color=$date_color>$rdate</font></td><td align=center><font size=-1 color=$read_color>$list[5]</font></td>$num_col</tr>\n";
			}
			$list_num--;
			if($d >= $page_num) { $page=1; last;  }
		}
        if($s eq "0"){
			if($down_view eq "yes"){
				$zero_col = "colspan=7";
			}
			else{
				$zero_col = "colspan=6";
			}
			print "<tr bgcolor=$cel_color1><td align=center $zero_col><font size=-1 color=red>^.^ ϵ  ϴ. ^.^</font></td></tr>\n";
        }
	}
	if($page!=1) {
		$scount = (($FORM{'page'}-1)*$page_num);
		$icount = 0;
		$d = 0; 
		$pre_pg= $FORM{'page'} - 1;
		$next_pg = $FORM{'page'} + 1;
		print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=#000000 width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
		if($next_pg <= $tot_pg) {
			print "<table width=$width  cellspacing=0 cellpadding=1 border=0><tr><td width=160 align=left><a href=$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}&action=form><img src=$img_url/write.gif border=0 alt=\" \"></a></td><td align=center><font size=1>Total <font color=red>$fil_data</font>articles [ <font color=green>$FORM{'page'}</font>/<font color=blue>$tot_pg</font> page ]</font></td><td width=160 align=right><a href=$cgi_url?id=$FORM{'id'}&page=$pre_pg><img src=$img_url/prev.gif border=0 alt=\" \"></a><a href=$cgi_url?id=$FORM{'id'}&page=$next_pg><img src=$img_url/next.gif border=0 alt=\" \"></a></td></tr></table>\n";
		}
		else {
			print "<table width=$width  cellspacing=0 cellpadding=1 border=0><tr><td width=160 align=left><a href=$cgi_url?id=$FORM{'id'}&action=form><img src=$img_url/write.gif border=0 alt=\" \"></a></td><td align=center><font size=1>Total <font color=red>$fil_data</font>articles [ <font color=green>$FORM{'page'}</font>/<font color=blue>$tot_pg</font> page ]</font></td><td width=160 align=right><a href=$cgi_url?id=$FORM{'id'}&page=$pre_pg><img src=$img_url/prev.gif border=0 alt=\" \"></a><img src=$img_url/next.gif border=0 alt=\" \"></td></tr></table>\n";
		}
		print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=#000000 width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
		print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=$head_color width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
		if($kind_view ne "yes"){
			$up_td = "";
		}
		else{
			$up_td = "<td>&nbsp;</td>";
		}
		
		print "<table width=$width border=0 cellpadding=$line_length cellspacing=0 bgcolor=$head_color><tr align=center><td align=left><font color=$cel_color1></font></td>$up_td<td align=center><font size=-1 color=$cel_color1>  </font></td><td align=center><font size=-1 color=$cel_color1>ۼ</font></td><td align=center width=100><font size=-1 color=$cel_color1>ۼϽ</font></td><td align=center width=30><font size=-1 color=$cel_color1>ȸ</font></td>$down_col</tr>\n";
		foreach $num (@remain) {
			$icount = $icount + 1;
			if($icount > $scount) {
				open(FILE,"<$main_dir/$num");
				@data = <FILE>;
				close (FILE);
			#-------------------------------------- [   ]---------------------------
			@down_data = split(/\|/,$data[5]);
			$file_name = "$down_data[5]";
			if($down_data[4] ne ""){
				@name_data = split(/\//,$down_data[4]);
				$n_num = @name_data - 1;
				if($name_data[$n_num] =~/\?/){
					@cgi = split(/\?/,"$name_data[$n_num]");
					$file_name = $cgi[1];
				}
				else{
					$file_name = "$name_data[$n_num]";
				}
				$f_name = "$down_data[4]";
				$file_size = "ũ";
			}
			else{
				$f_name = $file_name;
				$file_size = "$down_data[6]";
			}
			@file_type = split(/\./,$file_name);
			$type = $file_type[1];
			&file_icon;
			@unknown = split(/\./,$type);
			if($unknown[1] eq ""){
				$type = "unknown.gif";
			}
			if(($down_data[5] eq "") && ($down_data[4] eq "")) {
				$file_icon = "<img src=$img_url/type/text.gif border=0> ";
			}
			else{
				$file_icon = "<a href=\"$cgi_url?id=$FORM{'id'}&num=$num&action=down&file=$f_name\"><img src=$img_url/type/$type border=0 alt=\"$file_name($file_size) ٿޱ\"></a> ";
			}
			$down_num = $down_data[7];
			if($down_num eq ""){
				$down_num = "0";
			}
#------------------------------------------------------------------------------
				$d = ($d+1);
				$s=$scount+$d;
				$rotate = $d%2;
				if($rotate eq "0"){
					$tr_color=$cel_color2;
				}
				else{
					$tr_color=$cel_color1;
				}
				@list = split(/\|/, $data[1]);
			if($NT eq  "1"){
				if($list[1]) { 
					$mailto = "<a href=mailto:$list[1]>$list[0]</a>";
				}
				else {
					$mailto = $list[0];
				}   
			}
			else{
				if($list[1]) { 
					$mailto = "<a href=\"javascript:newin(350, 250, 'sendmail.cgi?name=$list[0]&mail=$list[1]&prog=$sendmail&home_url=$home_url','spmail')\">$list[0]</a>";
				}
				else {
					$mailto = $list[0];
				}   	
			}
				$rdate=substr($list[4],5,13);
				$old_date = substr($list[4],0,10);
				&getdate;
				$new_date = substr($date,0,10);
				if($old_date eq $new_date) {
					if($num =~/-/){
						$subject = "<img src=$img_url/newans.gif border=0>";	
					}
					else{
						$subject = "<img src=$img_url/newgul.gif border=0>";
					}
				} 
				else{ 
					if($num =~/-/){
						$subject = "<img src=$img_url/ans.gif border=0>";
					}
					else{
						$subject = "<img src=$img_url/gul.gif border=0>";
					}
				}  
				@push = split(/-/,$num);
				shift(@push);
				$x_num = @push;

#=================================[  üũ ]===================================================
				$gul_len = length($list[3]);
				if($gul_len > $sub_length){
					for( $k = 0; $k < $sub_length; ){
						if( ord(substr($list[3], $k, 1)) >= 128 ){
							$k+=2;
						}
						else{
							$k++;
						}
						last  if( $k >= $sub_length-$x_num*3 );
					}
					$list[3] = substr($list[3],0,($k));
					$list[3] = $list[3]."..."; 
				}
#======================================================================================================
				if($kind_view ne "yes"){
					$icon_td = "";
				}
				else{
					$icon_td = "<td width=16 align=center>$file_icon</td>";
				}
				if($down_view eq "yes"){
					$num_col = "<td align=center><font size=-1 color=blue><b>$down_num</b></font></td>";
				}
				$x_num *=17;
				if(($num eq $FORM{'number'}) && ($FORM{'action'} ne "modify_ok")){
					print "<tr bgcolor=$select_color><td><font color=$num_color size=-1>$list_num</td>$icon_td<td><img src=$img_url/zero.gif height=10 width=$x_num>$subject <u><b>$list[3]</b></u></font></td><td align=center><font size=-1>$mailto</font></td><td align=center width=100><font size=-1 color=$date_color>$rdate</font></td><td align=center><font size=-1 color=$read_color>$list[5]</font></td>$num_col</tr>\n";
				}
				else{
					print "<tr bgcolor=$tr_color><td><font color=$num_color size=-1>$list_num</td>$icon_td<td><img src=$img_url/zero.gif height=10 width=$x_num><a href=$cgi_url?id=$FORM{'id'}&page=$page&action=view&number=$num>$subject $list[3]</a></font></td><td align=center><font size=-1>$mailto</font></td><td align=center width=100><font size=-1 color=$date_color>$rdate</font></td><td align=center><font size=-1 color=$read_color>$list[5]</font></td>$num_col</tr>\n";
				}
			}
			$list_num--;
			if($d >= $page_num) { $page= $FORM{'page'}; last;}
		}
	}
	print "</table></td></tr></table><br>";
	&pagemove;
	&find;
	}
	&foot;
}

sub down_file {
		&lock;
	    &plus_num;
		&unlock;

		if(($FORM{'file'}=~ /http:\/\/.+/) || ($FORM{'file'}=~ /ftp:\/\/.+/)){
			print "Location:$FORM{'file'}\n\n";
		}
		else {
			print "Location:$main_url/files/$FORM{'file'}\n\n";	
		}	
		exit;
}

sub plus_num{
	open(VFILE, "$main_dir/$FORM{'num'}");
	@views = <VFILE>;
	close(VFILE);
	@Temp = split(/\|/, $views[5]);
	$Temp[7]++;
	open(NFI,">$main_dir/$FORM{'num'}");
	print NFI "$views[0]";
	print NFI "$views[1]";
	print NFI "$views[2]";
	print NFI "$views[3]";
	print NFI "$views[4]";
	print NFI "$Temp[0]|$Temp[1]|$Temp[2]|$Temp[3]|$Temp[4]|$Temp[5]|$Temp[6]|$Temp[7]|";
	close(NFI);
}

sub gul_list{
	opendir(READ_DIR, "$main_dir");
	@num_data = readdir(READ_DIR);
	$fil_data = @num_data-4;
	closedir(READ_DIR);
	$cou = 0;
	foreach $list_data (@num_data) {
		if(($list_data ne "notice.txt") && ($list_data ne "conf.txt") && ($list_data ne ".") && ($list_data ne "..")) {
			open(LIST, "$main_dir/$list_data");
			@gul_data = <LIST>;
			@line1 =split(/\|/, $gul_data[1]);
			@line2 = split(/\|/,$gul_data[2]);
			close (LIST);
			
			foreach $read_line (@gul_data) {
					$remain[$cou] = $list_data;
					$cou++;
					last;
			}
		} 
	}

	$tot_pg = int($cou/$page_num);
	if(($tot_pg*$page_num) < $cou) {$tot_pg = $tot_pg + 1; }
	@remain = sort {($b <=> $a) || ($a cmp $b)}(@remain);	#Ÿ ȣ ... ^.^
	$list_num = @remain;
}

sub file_icon{ # Ǫ ^.^  ̸  Լ...
	@icon = qw(unknown comp exe html note img mov ra sound);
	@1 = qw(zip rar arj ace tar);           #comp.gif 
	@2 = qw(bat com exe);                   #exe.gif 
	@3 = qw(html htm shtml);                      #htm.gif html  
	@4 = qw(hwp doc ppt cgi asp txt pl);               #note.gif 
	@5 = qw(bmp gif jpg jpeg pcx png tif);  #img.gif ׸
	@6 = qw(mov avi rm mpeg);               #mov.gif 
	@7 = qw(ra ram);                        #ra.gif 
	@8 = qw(mp3 wav mid);                   #sound.gif 
	
	for(1..8){
		for $key(@$_){ 
			if($type eq $key){
				$type = "$icon[$_].gif";
				$unknown = "0";
			}
		}
	}

	if($type eq ""){
		$type = "$icon[0].gif";
	}
}

sub read_notice{
	#========================[  üũ ]========================================
		if((-e "$main_dir/notice.txt") && ($FORM{'action'} ne "view")){
			open(FILE, "<$main_dir/notice.txt");
			@gul = <FILE>;
			@notice = split(/\|/,$gul[0]);
			close (FILE);
			$subject = $notice[1];
			$comment = $notice[2];
			$wdate = substr($notice[3],5,13);
			@die_date = split(/:/, $notice[4]);
			$die_year = $die_date[0];
			$die_mon = $die_date[1];
			$die_day = $die_date[2];
			$read_num = $notice[5];
			&getdate;
			if($down_view eq "yes"){
				$notice_td = "<td>&nbsp;</td>";
			}
			if($kind_view ne "yes"){
				$colspan = "colspan=2";
			}
			else{
				$colspan = "colspan=3";
			}
			if($die_year eq $year){
				if($die_day  < $mday){
					if($die_mon le $month){
						unlink ("$main_dir/notice.txt") ;
					}
					else{
						print "<tr bgcolor=$ncel_color><td $colspan><img src=$img_url/notice.gif> <a href=$cgi_url?id=$FORM{'id'}&action=view_notice><b>$subject</b></a></td><td align=center>$admin_name</td><td align=center><font color=$date_color>$wdate</font></td><td align=center><font color=$read_color>$read_num</font></td>$notice_td</tr>\n";
					}
				}
				else{
					if($die_mon < $month){
						unlink ("$main_dir/notice.txt") ;
					}
					else{
						print "<tr bgcolor=$ncel_color><td $colspan><img src=$img_url/notice.gif> <a href=$cgi_url?id=$FORM{'id'}&action=view_notice><b>$subject</b></a></td><td align=center>$admin_name</td><td align=center><font color=$date_color>$wdate</font></td><td align=center><font color=$read_color>$read_num</font></td>$notice_td</tr>\n";
					}
				}
			}
			elsif($die_year > $year){
				print "<tr bgcolor=$ncel_color><td $colspan><img src=$img_url/notice.gif><a href=$cgi_url?id=$FORM{'id'}&action=view_notice><font class=ad><b>$subject</b></font></a></td><td align=center>$admin_name</td><td align=center><font color=$date_color>$wdate</font></td><td align=center><font color=$read_color>$read_num</font></td>$notice_td</tr>\n";
			}
			else{
				unlink ("$main_dir/notice.txt") ;
			}
		}

#========================[  üũ ]========================================
}

sub view {
	open(VFILE, "$main_dir/$FORM{'number'}");
	@views = <VFILE>;
	close(VFILE);
	@Temp = split(/\|/, $views[1]);
	$auto_link = $views[4];
	@etc_data = split(/\|/,$views[5]);
	$ip=$etc_data[1];
	$domain=$etc_data[2];
	$down_num = $etc_data[7];
	if($down_num eq ""){
		$down_num = "0";
	}
	if($down_view eq "yes"){
		$down_count = "&nbsp; ٿ [ <b>$down_num</b> ]";
	}
	if(($ip ne "") && ($domain ne "") && ($view_ip eq "yes")){
		$w_info = "<p align=right><font class=ver8>$ip - $domain </font>"; 
	}
	else{
		$w_info = "<br>";
	}
	chop($auto_link);
	$pdate = substr($Temp[4],0,10);
	@md = split(/\//,$pdate);
	$year=$md[0];
	$month=$md[1];
	$sday=$md[2];
	$ptime = substr($Temp[4],12,5);
	@tm = split(/:/,$ptime);
	$stime = $tm[0];
	if($stime <= 11){
		$stime = " $stime";
	}
	elsif($stime == 12){
		$stime = " $stime";
	}
	else{
		$stime -= 12;
		$stime = " $stime";
	}
	$smin = $tm[1];
	if($Temp[2] ne ""){
		$homepage="<a href=$Temp[2] target=_blank><img src=$img_url/home.gif border=0 alt=\"$Temp[2]\"></a>";
	}
	else{
		$homepage="";
	}
	chop($Temp[5]);
	$Temp[5]++;
	&lock;
	open(NFI,">$main_dir/$FORM{'number'}");
	print NFI "$views[0]";
	print NFI "$Temp[0]|$Temp[1]|$Temp[2]|$Temp[3]|$Temp[4]|$Temp[5]\n";
	print NFI "$views[2]";
	print NFI "$views[3]";
	print NFI "$views[4]";
	print NFI "$views[5]";
	close(NFI);
	&unlock;
	@seper = split(/\|/,$views[2]);
	if ($seper[0] ne "1") { 
        $seper[1] =~ s/<br>/\r\n/g;
	    $seper[1] =~ s/<p>/\r\n\r\n/g;
	    $seper[1] =~ s/</&lt;/g;
        $seper[1] =~ s/>/&gt;/g;
        $seper[1] =~ s/"/&quot;/g;
	    $seper[1] =~ s/&lt;hr&gt;/<hr>/g;
	}
	$seper[1] =~ s/\r\n\r\n/<p>/g;
    $seper[1] =~ s/\r\n/<br>/g;
	if($auto_link eq "1"){
		$seper[1]=~ s/(http:\/\/)([\w\+\-\/\=\?\.\~]+)/$url <img src=$img_url\/home.gif> <a href=\"$1$2\" target=\"_new\">$1$2<\/a>/g;
		if($NT eq "1"){
			$seper[1]=~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/$mail <img src=$img_url\/mail.gif> <a href=\"mailto:$1\">$1<\/a>/g;
		}
		else{
			$seper[1]=~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/$mail <img src=$img_url\/mail.gif> <a href=\"javascript:newin(350, 250, 'sendmail.cgi?name=Guest&mail=$1&prog=$sendmail&home_url=$home_url','spmail')\">$1<\/a>/g;			
		}
	}
    if($etc_data[5] ne ""){
		$file_down = "<table border=0><tr><td><img src=$img_url/down.gif border=0 alt=\"ٿε\"></td><td><a href=\"$cgi_url?id=$FORM{'id'}&num=$FORM{'number'}&action=down&file=$etc_data[5]\"><font color=blue>$etc_data[5]</font></a> [ <font color=red>$etc_data[6]</font> ]</td></tr></table>";   
		
		if(($etc_data[3] ne "") && ($etc_data[3] ne "http://")){
			$pre_view = "<table border=0><tr><td><img src=$img_url/view.gif border=0 alt=\"̸\"></td><td><a href=$etc_data[3] target=_blank><font size=-1 color=blue≯</font></a></td></tr></table>";
		}
	}
	elsif($etc_data[4] ne ""){
		$file_down = "<table border=0><tr><td><a href=\"$cgi_url?id=$FORM{'id'}&num=$FORM{'number'}&action=down&file=$etc_data[4]\"><img src=$img_url/down.gif border=0 alt=\"ٿε\"></a></td><td> [ <a href=\"$cgi_url?id=$FORM{'id'}&num=$FORM{'number'}&action=down&file=$etc_data[4]\"><font color=red>ũ</font></a> ]</td></tr></table>";   
		
		if(($etc_data[3] ne "") && ($etc_data[3] ne "http://")){
			$pre_view = "<table border=0><tr><td><img src=$img_url/view.gif border=0 alt=\"̸\"></td><td><a href=$etc_data[3] target=_blank><font size=-1 color=blue≯</font></a></td></tr></table>";
		}
	}
	@apt = split(/-/,$FORM{'number'});
	$acou = @apt;

	if($views[3] eq "0") { 
		$subnumber = "$FORM{'number'}-1";
	}
	else { 
		$views[3]++;
		$subnumber = "$FORM{'number'}-$views[3]";
	}
	if($Temp[1]) { 
		if($NT eq "0"){
			$mailto = "<font color=$head_color>$Temp[0]</font> <a href=\"javascript:newin(350, 250, 'sendmail.cgi?name=$Temp[0]&mail=$Temp[1]&prog=$sendmail&home_url=$home_url','spmail')\"><img src=$img_url/mail.gif border=0 alt=$Temp[1]></a>"; 
		}
		else{
			$mailto = "<font color=$head_color>$Temp[0]</font> <a href=\"mailto:$Temp[1]\"><img src=$img_url/mail.gif border=0 alt=$Temp[1]></a>"; 
		}
	} 
	else{
		$mailto = "<font color=$head_color>$Temp[0]</font>";
	}
	&head;
	$link = "<td><table width=100% border=0 cellpadding=0 cellspacing=0><tr><td>$file_down</td><td>$pre_view</td></tr></table></td>\n";
print <<EOT;
<p>
<div align=center>
<table border=0 width=$width cellpadding=1 cellspacing=0>
<tr><td>ۼ [ $mailto $homepage ] - <font color=$date_color>$year $month $sday $stime $sminп  </font></td></tr>
<tr  bgcolor=$head_color><td>
<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=$head_color width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>
<table width=100% cellpadding=1 cellspacing=0>
<tr>
<td><font style="color:$cel_color1;font-size:10pt"> <b>$Temp[3]</b></font></td>
<td align=right><font color=$cel_color1>ȸ [ <b>$Temp[5]</b> ] $down_count</font> <a href=$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}&action=modify&number=$FORM{'number'}><img src=$img_url/modify.gif border=0 alt=\" ϱ\"></a> <a href=\"$cgi_url?id=$FORM{'id'}&action=erase&number=$FORM{'number'}&page=$FORM{'page'}&subject=$Temp[3]\"><img src=$img_url/remove.gif border=0 alt=\" ϱ\"></a> &nbsp;</td>
</tr></table></td>
</tr>
<tr bgcolor=$head_color><td align=center>
<table width=100% border=0 cellpadding=5 cellspacing=0 bgcolor=$cel_color1>
<tr><td height=220 valign=top class=cont><p class=t><table border=0 cellpadding=3 cellspacing=3>$link</tr></table> $seper[1]</font></td><tr><td align=right>$w_info &nbsp;  &nbsp; <br><br></td></tr></table>
</td></tr>
</table>
</td</tr>
</table>
</div>
<div align=center>

<table width=$width cellspacing=0 cellpadding=1 border=0>
<tr><td align=right>
EOT
	if($FORM{'category'} eq ""){
		if($acou >= 8) {
			print "<a href=$cgi_url?id=$FORM{'id'}&page=$page><img src=$img_url/list.gif border=0 alt=\"Ϻ\"></a>\n";
		}
		else {
			print "<a href=$cgi_url?id=$FORM{'id'}&action=reply&page=$page&subnumber=$subnumber&number=$FORM{'number'}><img src=$img_url/reply.gif border=0 alt=\"亯ۼ\"></a><a href=$cgi_url?id=$FORM{'id'}&page=$page><img src=$img_url/list.gif border=0 alt=\"Ϻ\"></a>\n";
		}
	}
	else{
			print "<a href=$cgi_url?action=search&id=$FORM{'id'}&page=$page&category=$FORM{'category'}&keyword=$FORM{'keyword'}><img src=$img_url/searchlist.gif border=0 alt=\"˻ list \"></a><a href=$cgi_url?id=$FORM{'id'}><img src=$img_url/backtolist.gif border=0 alt=\" \"></a>\n";
	}
	print "</td></tr></table></div>\n";
	$new = 1;
	$option = "view_data";
	&display;
	exit;
}

sub head {
		print "Content-type: text/html\n\n";
		print "<html>\n";
		print "<head>\n";
		print "<title>SP Board</title>\n";
		print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-KR\">\n";
		print "<style type='text/css'>\n";
		print "<!--\n";
		print "A:link {font:10pt ;color:black;text-decoration:none;}\n";
		print "A:visited {font:10pt ;color:black;text-decoration:none;}\n";
		print "A:active {font:10pt ;color:red;text-decoration:underline;}\n";
		print "A:hover {color:blue;text-decoration:underline;}\n";
		print ".ver8 {color:$head_color;font-family:Verdana,Arial,;font-size:8pt}\n";
		print "p,br,body,td,select,input,form,textarea,option {font-size:10pt;}\n";
		print ".ad{border:1 solid black}\n";
		print ".cont{line-height:140%}\n";
		print ".t{line-height:140%}\n";
		print "-->\n";
		print "</style>\n";
		print "<script language=\"JavaScript\">\n";
		print "	function newin(width,height,url,name) {\n";
		print "	msgWindow=window.open(url,name,'statusbar=no,scrollbars=yes,status=yes,resizable=yes,width='+width+',height='+height)\n";
		print "	}\n";
		print "</script>\n";
		print "</head>\n";
		if($background ne ""){
			$back="background=$background";
		}
		else{
			$back="bgcolor=$bgcolor";
		}
		print "<body $back>\n";
		if($logo_img ne ""){
			print "<center><a href=$cgi_url?id=$FORM{'id'}&action=admin_login><img src=$logo_img border=0 alt=\"  մϴ.\"></a>\n";
		}
		else{
			print "<center><div align=center><table cellpadding=1 cellspacing=0 border=0  bgcolor=$head_color><tr><td>\n";
			print "<table width=100% cellpadding=3 cellspacing=0 border=0 bgcolor=$cel_color1><tr><td  align=center> &nbsp; <a href=$cgi_url?id=$FORM{'id'}&action=admin_login>";
			print "<font color=$head_color>$logo_txt</font></a> &nbsp; </td></tr></table></td></tr></table></div>\n";
		}
		if(($quick1 eq "") || ($FORM{'action'} eq "form")){
			print "<p>\n";
		}
}

sub foot {
	print "<p>\n";
	print "<a href=\"http://sepal.woorizip.com\" target=\"_blank\"><font size=1 color=silver>Powered by Sepal - Board v3.0</font></a>\n";
	print "</center></body></html>\n";
	exit;
}

sub input_form{
	&read_cookie;
	&head;
	if($admin_only eq "yes"){
		print "<font color=$head_color>[˸!!!]</font>  Խ  <font color=$head_color>ڸ</font>  ְ Ǿϴ.\n";
	}
print <<START;
<form method=post enctype=multipart/form-data action=$cgi_url>
<input type=hidden name=action value=write>
<input type=hidden name=id value=$FORM{'id'}>
<input type=hidden name=ip value="$ENV{'REMOTE_ADDR'}">
<input type=hidden name=domain value="$ENV{'HTTP_USER_AGENT'}">
<table border=0 cellpadding=2 cellspacing=0 bgcolor=$head_color><tr><td>
<table border=0 cellpadding=2 cellspacing=3 bgcolor=$head_color>
<tr><td><font color=$cel_color1 size=-1>&nbsp;&nbsp; &nbsp;&nbsp;  </font></td><td><input type=text name=name value=\"$COOKIE{'UN'}\" size=10 maxlength="10" style="background-color:#ffffff;border:1 solid $head_color"> 
&nbsp; <font size=-1 color=$cel_color1>e-mail</font> <input type=text name=email value=\"$COOKIE{'UM'}\" size=15 style="background-color:#ffffff;border:1 solid $head_color"></td></tr>
<tr><td align=center><font size=-1 color=$cel_color1>Ȩ</font></td><td>
START
	if($COOKIE{'UH'} eq "") {
		print"<input type=text name=homepage size=35 value=\"http://\" style=\"background-color:#ffffff;border:1 solid $head_color\">\n";
	}
	else{
		print"<input type=text name=homepage size=35 value=\"$COOKIE{'UH'}\" style=\"background-color:#ffffff;border:1 solid $head_color\">\n";
	}
print <<START;
</td></tr>
<tr><td align=center><font size=-1 color=$cel_color1>йȣ</font></th><td><input type=password name=passwd size=10 style="background-color:#ffffff;border:1 solid $head_color"> <input type=checkbox name=html value=1><font size=-1 color=$cel_color1>html</font> <input type=checkbox name=auto_link value=1 checked><font size=-1 color=$cel_color1>home, mail ڵũ  &nbsp;</font></td></tr>
<tr><td align=center><font size=-1 color=$cel_color1> &nbsp;&nbsp; &nbsp;&nbsp;</font></th><td><input type=text name=subject size=43 style="background-color:#ffffff;border:1 solid $head_color"></td></tr>
START

if($pds_ok eq "yes"){
	print "<tr><td align=center><font size=-1 color=$cel_color1≯</font></th><td><input type=text name=pre_view size=43 maxlength=66 value=\"http:\/\/\" style=\"background-color:#ffffff;border:1 solid $head_color\"></td></tr>\n";
}

print "<tr><td valign=top><br><font color=$cel_color1 size=-1>&nbsp;&nbsp; &nbsp;&nbsp;  </font></td><td><textarea name=comments rows=8 cols=45 style=\"background-color:#ffffff;border:1 solid $head_color\"></TextArea></td></tr>\n";

if($pds_ok eq "yes"){
	print "<tr><td colspan=2 align=center><table border=0 cellpadding=2><tr><td><font sieze=-1 color=$cel_color1>!!! ϸ ĭ ϸ ȵ˴ϴ.</font></td></tr><tr><td><font sieze=-1 color=$cel_color1>ex) sepal.zip(<b>O</b>) &nbsp; &nbsp; se pal.zip(<b>X</b>)</font></td></tr></table></td></tr>\n";
	print "<tr><td align=center><font size=-1 color=$cel_color1>÷</font></td><td><input name=file_name type=file size=43 style=\"width:90%;border:1 solid black\"></td></tr>\n";
	print "<tr><td align=center><font size=-1 color=$cel_color1>ũ</font></td><td><input name=link_file type=text size=42 style=\"background-color:#ffffff;border:1 solid $head_color\"></td></tr>\n";
}
print <<END;
<tr><td align=center colspan=2><input type=submit value="ۿø" style="background-color:$cel_color1;border:1 solid $head_color;height:20"> <input type=reset value="ٽۼ" style="background-color:$cel_color1;border:1 solid $head_color;height:20"></td></tr></table></td></tr></table>
</form>
<a href=$cgi_url?id=$FORM{'id'}><img src=$img_url/backtolist.gif border=0 alt=" "></a>
END
	&foot;
}

sub notice_form{
	if($FORM{'passwd'} eq $admin){
		&head;
print <<START;
<p>
[ ]
<form method=post action=$cgi_url>
<input type=hidden name=action value=adminwrite>
<input type=hidden name=id value=$FORM{'id'}>
<table border=0 cellpadding=3 cellspacing=0 bgcolor=$head_color><tr><td>
<table border=0 cellpadding=3 cellspacing=3 bgcolor=$head_color>
</td></tr>
<tr><td align=center><font size=-1 color=$cel_color1></font></th><td>
<input type=text name=die_year size=4 maxlength=4 style="background-color:#ffffff;border:1 solid $head_color"><font size=-1 color=$cel_color1></font>
<input type=text name=die_mon size=2 maxlength=2 style="background-color:#ffffff;border:1 solid $head_color"><font size=-1 color=$cel_color1></font> 
<input type=text name=die_day size=2 maxlength=2 style="background-color:#ffffff;border:1 solid $head_color"><font size=-1 color=$cel_color1>
(: 20000801)</font></td></tr>
<tr><td align=center><font size=-1 color=$cel_color1> &nbsp;&nbsp; &nbsp;&nbsp;</font></th><td><input type=text name=subject size=40 style="background-color:#ffffff;border:1 solid $head_color"> <input type=checkbox name=html value=1><font size=-1 color=$cel_color1>html</font>  <input type=checkbox name=auto_link value=1 checked><font size=-1 color=$cel_color1>auto link</font></td></tr>
<tr><td colspan=2 align=center><textarea name=comments rows=8 cols=55 style="background-color:#ffffff;border:1 solid $head_color"></TextArea></td></tr>
<tr><td align=center colspan=2><input type=submit value="ۿø" style="background-color:$cel_color1;border:1 solid $head_color;height:20"> <input type=reset value="ٽۼ" style="background-color:$cel_color1;border:1 solid $head_color;height:20"></td></tr></table></td></tr></table>
</form>
<a href=$cgi_url?id=$FORM{'id'}><img src=$img_url/backtolist.gif border=0 alt=" "></a>
START
		&foot;
	}
	else{
			$err = pass;
			&error;
	}
}

sub modify_form {
	open(DATA,"<$main_dir/$FORM{'number'}");
	@data = <DATA>;
	chop(@data);
	$pass=$data[0];
	@wdata= split(/\|/,$data[1]);
	$name=$wdata[0];
	$email=$wdata[1];
	$homepage=$wdata[2];
	$subject=$wdata[3];
	$wdate=$wdata[4];
	$readnum=$wdata[5];
	@seper= split(/\|/,$data[2]);
	$html=$seper[0];
	if ($html eq "1") {
		$htmlvalue = "checked";
	}
	else{
		$htmlvalue = "";
	}
	$seper[1] =~ s/<br>/\n/g;
	$comment=$seper[1];
	$ansnum=$data[3];
	$auto_link = $data[4];
	if ($auto_link eq "1") {
		$autovalue = "checked";
	}
	else{
		$autovalue = "";
	}
	@pds_data = split(/\|/,$data[5]);
	$pv_value = $pds_data[3];
	$link_value = $pds_data[4];
	$file_name = $pds_data[5];
	$file_size = $pds_data[6];
	$down_num = $pds_data[7];
	close (DATA);

	if($link_value ne ""){
		$link_update = "<tr><td align=center><font size=-1 color=$cel_color1>ũ</font></td><td><input name=link_file type=text value=\"$link_value\" size=43 style=\"background-color:#ffffff;border:1 solid $head_color\"></td></tr>";
	}

	&head;
print <<START;
<form method=post action=$cgi_url>
<input type=hidden name=action value="modify_ok">
<input type=hidden name=id value="$FORM{'id'}">
<input type=hidden name=page value="$FORM{'page'}">
<input type=hidden name=number value="$FORM{'number'}">
<input type=hidden name=ansnum value="$ansnum">
<input type=hidden name=readnum value="$readnum">
<input type=hidden name=date value="$wdate">
<input type=hidden name=file_name value="$file_name">
<input type=hidden name=file_size value="$file_size">
<input type=hidden name=ip value="$ENV{'REMOTE_ADDR'}">
<input type=hidden name=domain value="$ENV{'HTTP_USER_AGENT'}">
<input type=hidden name=down_num value="$down_num">
<table border=0 cellpadding=1 cellspacing=0 bgcolor=$head_color>
<tr><td bgcolor=$cel_color1>
<font color=$head_color> <b>$name</b>  մϴ.</font>
</td></tr>
<tr><td>
<table border=0 cellpadding=3 cellspacing=0 bgcolor=$head_color>
<tr><td align=center><font color=$cel_color1 size=-1>&nbsp;&nbsp; &nbsp;&nbsp;  </font></td>
<td><input type=text name=name size=10 maxlength="10" value="$name" style="background-color:#ffffff;border:1 solid $head_color"> 
&nbsp; <font size=-1 color=$cel_color1>e-mail</font> <input type=text name=email size=15 value="$email" style="background-color:#ffffff;border:1 solid $head_color"></td></tr>
<tr><td align=center><font size=-1 color=$cel_color1>Ȩ</font></th><td><input type=text name=homepage size=35 value="$homepage" style="background-color:#ffffff;border:1 solid $head_color"></td></tr>
<input type=hidden name=passwd size=8 value="$pass">
<tr><td>&nbsp;</td><td><input type=checkbox name=html value=1 $htmlvalue><font size=-1 color=$cel_color1>html</font>&nbsp;  <input type=checkbox name=auto_link value=1 $autovalue><font size=-1 color=$cel_color1>home, mail ڵũ </font></td></tr>
<tr><td align=center><font size=-1 color=$cel_color1> &nbsp;&nbsp; &nbsp;&nbsp;</font></th><td><input type=text name=subject size=43 value="$subject" style="background-color:#ffffff;border:1 solid $head_color"></td></tr>
START
	if($pds_ok eq "yes"){
		print "<tr><td align=center><font size=-1 color=$cel_color1≯</font></th><td><input type=text name=pre_view value=\"$pv_value\" size=43 maxlength=66 style=\"background-color:#ffffff;border:1 solid $head_color\"></td></tr>\n";
	}
	print "<tr><td valign=top><br><font size=-1 color=$cel_color1> &nbsp;&nbsp; &nbsp;&nbsp;</font></td><td><textarea name=comments rows=8 cols=43 style=\"background-color:#ffffff;border:1 solid $head_color\">$comment</TextArea> &nbsp; </td></tr>\n";

	if($pds_ok eq "yes"){
		print "$link_update\n";
	}
print <<END;
<tr><td align=center colspan=2><input type=submit value="ϱ" style="background-color:$cel_color1;border:1 solid $head_color;height:20"> <input type=reset value="ٽۼ" style="background-color:$cel_color1;border:1 solid $head_color;height:20"></td></tr></table></td></tr></table>
</form>
<a href=$cgi_url?id=$FORM{'id'}><img src=$img_url/backtolist.gif border=0 alt=" "></a>
END

	&foot;

}

sub admin_modify_form {
	open(DATA,"<$main_dir/notice.txt");
	@data = <DATA>;
	@notice = split(/\|/,$data[0]);
	$html=$notice[0];
	$auto_link = $data[1];
	chop($auto_link);
	$subject = $notice[1];
	$notice[2] =~ s/<br>/\n/g;
	$comment = $notice[2];
	$wdate = $notice[3];
	@die_date=split(/:/,$notice[4]);
	$die_year = $die_date[0];
	$die_mon = $die_date[1];
	$die_day = $die_date[2];
	$read_num = $notice[5];
	if ($html eq "1") {
		$htmlvalue = "checked";
	}
	else{
		$htmlvalue = "";
	}
	if ($auto_link eq "1") {
		$autovalue = "checked";
	}
	else{
		$autovalue = "";
	}
	close (DATA);

	&head;
print <<START;
<p>
[ ϱ]
<form method=post action=$cgi_url>
<input type=hidden name=action value=adminwrite>
<input type=hidden name=read_num value=$read_num>
<input type=hidden name=id value=$FORM{'id'}>
<table border=0 cellpadding=3 cellspacing=0 bgcolor=$head_color><tr><td>
<table border=0 cellpadding=3 cellspacing=3 bgcolor=$head_color>
</td></tr>
<tr><td align=center><font size=-1 color=$cel_color1></font></th><td>
<input type=text name=die_year size=4 maxlength=4 value="$die_year" style="background-color:#ffffff;border:1 solid $head_color"><font size=-1 color=$cel_color1></font>
<input type=text name=die_mon size=2 maxlength=2 value="$die_mon" style="background-color:#ffffff;border:1 solid $head_color"><font size=-1 color=$cel_color1></font> 
<input type=text name=die_day size=2 maxlength=2 value="$die_day" style="background-color:#ffffff;border:1 solid $head_color"><font size=-1 color=$cel_color1>
(: 20000801)</font></td></tr>
<tr><td align=center><font size=-1 color=$cel_color1> &nbsp;&nbsp; &nbsp;&nbsp;</font></th><td><input type=text name=subject size=40 value="$subject" style="background-color:#ffffff;border:1 solid $head_color"> <input type=checkbox name=html value=1 $htmlvalue><font size=-1 color=$cel_color1>html</font>  <input type=checkbox name=auto_link value=1 $autovalue><font size=-1 color=$cel_color1>auto link</font></td></tr>
<tr><td colspan=2 align=center><textarea name=comments rows=8 cols=55 style="background-color:#ffffff;border:1 solid $head_color">$comment</TextArea></td></tr>
<tr><td align=center colspan=2><input type=submit value="ۿø" style="background-color:$cel_color1;border:1 solid $head_color;height:20"> <input type=reset value="ٽۼ" style="background-color:$cel_color1;border:1 solid $head_color;height:20"></td></tr></table></td></tr></table>
</form>
<a href=$cgi_url?id=$FORM{'id'}><img src=$img_url/backtolist.gif border=0 alt=" "></a>
START
	&foot;
}

sub read_cookie{

    if($ENV{'HTTP_COOKIE'}) {
        @cookies = split(/; /,$ENV{'HTTP_COOKIE'});
        foreach(@cookies) {
        ($name,$value) = split(/=/,$_);
        $COOKIE{$name} = $value;
        }
	}
}

sub admin_login {
	&head;
print <<START;
<p>&nbsp;
<p>&nbsp;
<table border="0" cellpadding="2" cellspacing="0" width="430" bgcolor="$head_color">
    <tr>
        <td><table border="0" cellpadding="2" cellspacing="0" width="100%"
             bgcolor="$cel_color1">
                <tr>
                    <td height=120><p align="center"><font size="2" color="red"> </font> մϴ.<br> йȣ  ֽð Ȯ ư  
                        ּ.
						<form method=post action=$cgi_url>
						<input type=hidden name=id value=$FORM{'id'}>
						<input type=hidden name=action value=loginok>
						<div align=center><table><tr><td>йȣ</td><td><input type=password name=passwd size=10 style="background-color:$cel_color1;border:1 solid $head_color"></td><td><input type=submit value=\"Ȯ\" style="color:black;background-color:$cel_color1;border:1 solid $head_color;height:21px"></td><td>
						</td></tr></table></div>
						</form>
					</td>
                </tr>
	           </table></td>
    </tr>
</table>
START
&foot;
}

sub admin_ok {
	&head;
print <<START;
<p>&nbsp;
<p>&nbsp;
<table border="0" cellpadding="2" cellspacing="0" width="430" bgcolor="$head_color">
    <tr>
        <td><table border="0" cellpadding="2" cellspacing="0" width="100%"
             bgcolor="$cel_color1">
                <tr>
                    <td height=120><p>&nbsp;<p align="center"><font size="2" color="red"> մϴ.<br> йȣ  ֽð Ȯ ư  
                       ּ.</font>
						<form method=post action=$cgi_url>
						<input type=hidden name=id value=$FORM{'id'}>
						<input type=hidden name=action value=admin_ok>
						<div align=center><table>
						<tr><td>йȣ</td><td><input type=password name=passwd size=10 style="background-color:$cel_color1;border:1 solid $head_color"></td><td><input type=submit value="Ȯ" style="color:black;background-color:$cel_color1;border:1 solid $head_color;height:21px">
						</td></tr></table>
						</div>
						</form>
					</td>
                </tr>
            </table></td>
    </tr>
</table>
START
&foot;
}

sub admin_remove {
	&head;
print <<START;
<p>&nbsp;
<p>&nbsp;
<table border="0" cellpadding="2" cellspacing="0" width="430" bgcolor="$head_color">
    <tr>
        <td><table border="0" cellpadding="2" cellspacing="0" width="100%"
             bgcolor="$cel_color1">
                <tr>
                    <td height=120><p align="center"><font size="2" color="red"> մϴ.<br> йȣ  ֽð Ȯ ư  
                        ּ.</font>
						
						<form method=post action=$cgi_url>
								<input type=hidden name=id value=$FORM{'id'}>
								<input type=hidden name=action value=admin_remove_ok>
								<div align= center><table><tr><td>йȣ</td><td><input type=password name=passwd size=10 style="background-color:$cel_color1;border:1 solid $head_color"></td><td><input type=submit value=\"Ȯ\" style="color:black;background-color:$cel_color1;border:1 solid $head_color;height:21px"></td><td>
								</td></tr>
								</table></div>
						</form>
						</td>
                </tr>
            </table></td>
    </tr>
</table>


START
&foot;
}

sub enterpass{
	&head;
print <<START;
<p>&nbsp;
<p>&nbsp;
<h3>йȣ ԷϽÿ.</h3>

<form method=post action=$cgi_url>
<input type=hidden name=action value=passok>
<input type=hidden name=page value=$FORM{'page'}>
<input type=hidden name=id value=$FORM{'id'}>
<input type=hidden name=number value=$FORM{'number'}>
<table><tr><td>йȣ</td><td><input type=password name=passwd size=10 style="background-color:#ffffff;border:1 solid $head_color"></td><td><input type=submit value="enter" style="background-color:$cel_color1;border:1 solid $head_color;height:20"></td><td></form></td></tr></table>
START
	&foot;
}

sub passok{
	$pass = crypt($FORM{'passwd'},sp);
	open(FILE,"<$main_dir/$FORM{'number'}");
	@filea = <FILE>;
	close (FILE);
	chop($filea[0]);
	if($pass eq ""){
		$err = pass;
		&error;
	}elsif(($filea[0] eq $pass) || ($admin eq $pass)) {
		&modify_form;
	}else{
		$err = pass;
		&error;
	}
}

sub write {
	print "Set-Cookie: UN=$FORM{'name'}; expires=Sunday, 12-Dec-2000 12:12:12 GMT;\r\n";
	print "Set-Cookie: UM=$FORM{'email'}; expires=Sunday, 12-Dec-2000 12:12:12 GMT;\r\n";
	print "Set-Cookie: UH=$FORM{'homepage'}; expires=Sunday, 12-Dec-2000 12:12:12 GMT;\r\n";
	
	$pass = crypt($FORM{'passwd'},sp);
	
	if(($admin_only eq "yes") && ($admin ne $pass)){
		$err = admin;
		&error;
	}
		
	if($FORM{'file_name'} ne ""){
		if($FORM{'link_file'} eq ""){
			&upload_file;
		}
		else{
			$err = double;
			&error;
		}
	}
	elsif($FORM{'link_file'} ne ""){
		if(($FORM{'link_file'} =~ /^http:\/\//) || ($FORM{'link_file'}=~ /^ftp:\/\//)) {
        }
        else {
			$err = "link";
            &error;
        }
	}

	$FORM{'comments'} =~ s/\cM//g;
	$FORM{'comments'} =~ s/\n/<br>/g;
	$FORM{'comments'} =~ s/\|/&#124;/g;

	$lengh = length($FORM{'comments'});
#######################################################	
	if($FORM{'subnumber'} eq "") {
		&gul_list;
		$num=$remain[0];
		while(-e "$main_dir/$num"){
			$num++;
		}
	}
#######################################################

	if(($FORM{'homepage'} ne "") && $FORM{'homepage'} ne "http://"){
		$home="$FORM{'homepage'}";	}
	else{
	$home="";
	}
	&getdate;
	
	if($FORM{'subnumber'} eq "") {
		open(WFILE,">$main_dir/$num");
		print WFILE "$pass\n";
		print WFILE "$FORM{'name'}|$FORM{'email'}|$home|$FORM{'subject'}|$date|0\n";
		print WFILE "$FORM{'html'}|$FORM{'comments'}\n";
        print WFILE "0\n";
		print WFILE "$FORM{'auto_link'}\n";
		print WFILE "|$FORM{'ip'}|$FORM{'domain'}|$FORM{'pre_view'}|$FORM{'link_file'}|$org_name|$size|0|\n";
		close(WFILE);
	}
	else {
		open(Sum,"<$main_dir/$FORM{'num'}");
		@est = <Sum>;
		close(Sum);   
		@mail = split(/\|/,$est[1]);
		$addr = $mail[1];

		chop($est[3]);
		$est[3]++;
		open(Suma,">$main_dir/$FORM{'num'}");
		print Suma "$est[0]";
		print Suma "$est[1]";
		print Suma "$est[2]";
		print Suma "$est[3]\n";
		print Suma "$est[4]";
		print Suma "$est[5]";
		close(Suma);

		open(WFILE,">$main_dir/$FORM{'subnumber'}");
		print WFILE "$pass\n";
		print WFILE "$FORM{'name'}|$FORM{'email'}|$home|$FORM{'subject'}|$date|0\n";
		print WFILE "$FORM{'html'}|$FORM{'comments'}\n";
		print WFILE "0\n";
		print WFILE "$FORM{'auto_link'}\n";
		print WFILE "|$FORM{'ip'}|$FORM{'domain'}|$FORM{'pre_view'}|$FORM{'link_file'}|$org_name|$size|0|\n";
		close(WFILE);
		if(($addr) && ($smail == "yes")) {
			&sendmail; 
		}
	}            
	if($num > $max_data ) {
		$count = 0;
		until($num <= 0) {
			if (-e "$main_dir/$num") {
					$count = ($count + 1); 
			}
			$num = ($num - 1);
			if($count >= $max_data) {
				last  
			}
		}
        until($num <=0) {

			open(FILE,"<$main_dir/$num");
			@filea = <FILE>;
			close (FILE);
			unlink ("$main_dir/$num") ;
			if($filea[3] > 0) {
				&auto_erase;
			}
			$num = ($num - 1);
		}
	}
	&load_page;
}

 sub upload_file {
	$upfile = $FORM{'file_name'};
	@a = split(/\"/,$real_file);
	@b = split(/\\/,$a[3]);
	$t = @b;
	$org_name = ($b[$t-1]);
	$filename = "$main_dir/files/".$org_name;
	if(-e $filename){
		$err = exist;
		&error;
	}
    open(FILE, ">$filename") || exit(1);
    binmode FILE; 
    print FILE $upfile;
    close FILE;
	$size = (-s "$main_dir/files/$org_name");
	if($size > ($max_size*1048576)){
		unlink("$main_dir/files/$org_name");
		$err = size;
		&error;
	}
	
	if($size >= 1048576) { 
		$size = substr(($size/1048576),0,3);
		@dot=split(/\./,$size);
		if($dot[1] eq ""){
			$size = "$dot[0] MB";
		}
		else{
			$size = "$size MB";
		}
	}
	elsif($size >= 1024) {
		$size = substr(($size/1024),0,3);
		@dot=split(/\./,$size);
		if($dot[1] eq ""){
			$size = "$dot[0] KB";
		}
		else{
			$size = "$size KB";
		}
	}
	else{
		$size = "$size byte";
	}

}

sub modify {
	$FORM{'comments'} =~ s/\cM//g;
	$FORM{'comments'} =~ s/\n/<br>/g;
	$FORM{'comments'} =~ s/\|/&#124;/g;
	$lengh = length($FORM{'comments'});
	&lock;
	open(WFILE,">$main_dir/$FORM{'number'}");
	print WFILE "$FORM{'passwd'}\n";
	print WFILE "$FORM{'name'}|$FORM{'email'}|$FORM{'homepage'}|$FORM{'subject'}|$FORM{'date'}|$FORM{'readnum'}\n";
	print WFILE "$FORM{'html'}|$FORM{'comments'}\n";
    print WFILE "$FORM{'ansnum'}\n";
	print WFILE "$FORM{'auto_link'}\n";
	print WFILE "|$FORM{'ip'}|$FORM{'domain'}|$FORM{'pre_view'}|$FORM{'link_file'}|$FORM{'file_name'}|$FORM{'file_size'}|$FORM{'down_num'}|\n";
	close(WFILE);
	&unlock;
	&load_page;
}

sub adminwrite {
	$FORM{'comments'} =~ s/\cM//g;
	$FORM{'comments'} =~ s/\n/<br>/g;
	$FORM{'comments'} =~ s/\|/&#124;/g;

	$lengh = length($FORM{'comments'});
	&getdate;
	open(WFILE,">$main_dir/notice.txt");
	if($FORM{'read_num'} eq ""){
		print WFILE "$FORM{'html'}|$FORM{'subject'}|$FORM{'comments'}|$date|$FORM{'die_year'}:$FORM{'die_mon'}:$FORM{'die_day'}|0|\n";
	}
	else{
		print WFILE "$FORM{'html'}|$FORM{'subject'}|$FORM{'comments'}|$date|$FORM{'die_year'}:$FORM{'die_mon'}:$FORM{'die_day'}|$FORM{'read_num'}|\n";
	}
	print WFILE "$FORM{'auto_link'}\n";
	close(WFILE);
	&load_page;
}

sub reply_form {
	&read_cookie;
	&head;
	open(Replay, "$main_dir/$FORM{'number'}");
	@repl = <Replay>;
	close(Replay);
		
	@repla = split(/\|/, $repl[1]);	
	@seper = split(/\|/, $repl[2]);	
	$seper[1] =~ s/<br>/\n>/g;
	$seper[1] =~ s/<hr>/\n<hr>\n>/g;
	$seper[1] =~ s/textarea/ýƮ /g;
	$repla[3] =~ s/\"/ /g;

	@arp = split(/-/,$FORM{'number'});
	$scut = @arp;
	if($scut < 2) { $ford = ":";}

	if($admin_only eq "yes"){
		print "<font color=$head_color>[˸!!!]</font>  Խ  <font color=$head_color>ڸ</font>  ְ Ǿϴ.\n";
	}
print <<START;
<form method=post action=$cgi_url enctype=multipart/form-data>
<input type=hidden name=action value=write>
<input type=hidden name=subnumber value=$FORM{'subnumber'}>
<input type=hidden name=num value=$FORM{'number'}>
<input type=hidden name=id value=$FORM{'id'}>
<input type=hidden name=page value=$page>
<input type=hidden name=ip value="$ENV{'REMOTE_ADDR'}">
<input type=hidden name=domain value="$ENV{'HTTP_USER_AGENT'}">
<table border=0 cellpadding=3 cellspacing=0 bgcolor=$head_color>
<tr bgcolor=$ncel_color><td><font size=-1 color=$head_color> <b>$repla[0]</b>Բ  ۿ 亯 ۼ</font></td></tr>
<tr><td>
<table border=0 cellpadding=2 cellspacing=2 bgcolor=$head_color>
<tr><td align=center><font color=$cel_color1 size=-1>&nbsp;&nbsp; &nbsp;&nbsp;  </font></td><td><input type=text name=name size=10 maxlength=10 value=\"$COOKIE{'UN'}\" style=\"background-color:#ffffff;border:1 solid $head_color\">
&nbsp; <font size=-1 color=$cel_color1>e-mail</font> <input type=text name=email size=15 value=\"$COOKIE{'UM'}\" style=\"background-color:#ffffff;border:1 solid $head_color\"></td></tr>
<tr><td align=center><font size=-1 color=$cel_color1>Ȩ</font></th><td>
START
	if($COOKIE{'UH'} eq "") {
		print"<input type=text name=homepage value=\"http://\" size=35 style=\"background-color:#ffffff;border:1 solid $head_color\">\n";
	}
	else{
		print"<input type=text name=homepage value=\"$COOKIE{'UH'}\" size=35 style=\"background-color:#ffffff;border:1 solid $head_color\">\n";
	}
print <<MID;
</td></tr>
<tr><td align=center><font size=-1 color=$cel_color1>йȣ</font></th><td><input type=password name=passwd size=10 style=\"background-color:#ffffff;border:1 solid $head_color\"> <input type=checkbox name=html value=1><font size=-1 color=$cel_color1>html</font> <input type=checkbox name=auto_link value=1 checked><font size=-1 color=$cel_color1>home, mail ڵũ </font> &nbsp;</td></tr>
<tr><td align=center><font color=$cel_color1 size=-1>&nbsp;&nbsp; &nbsp;&nbsp;  </font></th><td><input type=text name=subject size=43 value="$ford$repla[3]" style=\"background-color:#ffffff;border:1 solid $head_color\"></td></tr>
MID

	if($pds_ok eq "yes"){
		print "<tr><td align=center><font size=-1 color=$cel_color1≯</font></th><td><input type=text name=pre_view size=43 maxlength=66 value=\"http:\/\/\" style=\"background-color:#ffffff;border:1 solid $head_color\"></td></tr>\n";
	}

print <<END;
<tr><td valign=top><br><font color=$cel_color1 size=-1>&nbsp;&nbsp; &nbsp;&nbsp;  </font></td><td><textarea name=comments rows=8 cols=45 style=\"background-color:#ffffff;border:1 solid $head_color\">
	\n\n<hr>\n\n>[$repla[0]Բ  ]\n\n>$seper[1]</textarea></td></tr>
END
	if($pds_ok eq "yes"){
		print "<tr><td colspan=2 align=center><table border=0 cellpadding=2><tr><td><font sieze=-1 color=$cel_color1>!!! ϸ ĭ ϸ ȵ˴ϴ.</font></td></tr><tr><td><font sieze=-1 color=$cel_color1>ex) sepal.zip(<b>O</b>) &nbsp; &nbsp; se pal.zip(<b>X</b>)</font></td></tr></table></td></tr>\n";
		print "<tr><td align=center><font size=-1 color=$cel_color1>÷</font></td><td><input name=file_name type=file size=40 style=\"width:90%;border:1 solid black\"></td></tr>\n";
		print "<tr><td align=center><font size=-1 color=$cel_color1>ũ</font></td><td><input name=link_file type=text size=43 style=\"background-color:#ffffff;border:1 solid $head_color\"></td></tr>\n";
	}
print <<END;
<tr><td align=center colspan=2><input type=submit value="ۿø" style="background-color:$cel_color1;border:1 solid $head_color;height:20"> <input type=reset value="ٽۼ" style="background-color:$cel_color1;border:1 solid $head_color;height:20"></td></tr></table></td></tr></table>
</form>
<a href=$cgi_url?id=$FORM{'id'}><img src=$img_url/backtolist.gif border=0 alt=" "></a>
END
	&foot;
}

sub getdate {
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	if ($sec < 10)  { $sec = "0$sec";   }
	if ($min < 10)  { $min = "0$min";   }
	if ($hour < 10) { $hour = "0$hour"; }
	if ($mday < 10) { $mday = "0$mday"; }
	if ($mon < 10)  { $mon = "0$mon";  }
	$month = ($mon + 1);
	if ($month < 10)  { $month = "0$month";  }
	if($year ne "99"){
		if($year > 100){
			$year=($year-100)+2000;
		}
		elsif($year < 10){
			$year=2000+$year;	
		}
		else{
			$year="2000";
		}
	}
	else{
		$year="1999";
	}
	$date = "$year/$month/$mday [$hour:$min]"; 
}

sub load_page{
	if($FORM{'page'} eq ""){
		$FORM{'page'} = "1";
	}
	&head;
	print "<META HTTP-EQUIV=Refresh CONTENT=1;URL=$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}>\n";
	print "<p>&nbsp;<p>&nbsp;<p>&nbsp;<hr width=300 noshade>\n";
	print "Loading ......\n";
	print "<hr width=300 noshade>\n";
	print "<br><br><a href=$cgi_url?id=$FORM{'id'}><font color=#FFA8E3></font><font color=#92B8FF></font> Խ ư</a>\n";
	&foot;
}

sub error {
  &head;
  if($err eq id) {
	  print "<h2><u>Խ̸ </u></h2>\n";
	  print "ϰ 䱸ϴ Խ ã  ϴ<br>\n";
	  print "ݵ board.cgi?<font color=red>id=db</font>  ҷ մϴ.\n";
  }
  elsif($err eq pass) {
	 print "<H2><u>йȣ </u></H2>\n";
	 print "йȣ ġ ʽϴ.\n";
  }
  elsif($err eq admin) {
	 print "<H2><u>йȣ </u></H2>\n";
	 print "  Խ ڸ    ֽϴ.<br>  йȣ ġ ʽϴ.\n";
  }
  elsif($err eq "exist") {
	 print "<H2><u> ̸  մϴ. </u></H2>\n";
	 print "̸ ٲٽ ÷ּ...\n";
  }
  elsif($err eq keyword) {
	 print "<H2><u>˻ Է </u></H2>\n";
	 print "˻ ԷϽ ̾<br>˻Ϸ ˻ Էϼ\n";
  }
  elsif($err eq size) {
	 print "<H2><u>  ʹ Ŀ... </u></H2>\n";
	 print " ø ִ <font color=blue>ִ 뷮</font> ϴ <font color=red>$max_size MB</font> Դϴ.<br>ڷ 뷮    ÷ּ.\n";
  }
  elsif($err eq double) {
	 print "<H2><u> ϳ մϴ. </u></H2>\n";
	 print "<font color=red>ϸũ</font> <font color=red>Ͼε</font>  ϳ  ּ...\n";
  }
  elsif($err eq "link") {
		print "<H2><u> ũ <font color=red>http:\/\/</font> Ǵ <font color=red>ftp:\/\/</font>   ؾ մϴ.</u></H2>";
  }
  else{
	 print "<H2><u>Խ ۼ </u></H2>\n";
	 print "̸, ,  ݵ äž մϴ\n";
  }
  print "<p>ڷ ư ٽ õ Ͻʽÿ.<br><br>\n";
  print "<a href=\"javascript:history.go(-1)\">ٽýõ(BACK)</a>\n";
  &foot;	
  exit;
}

sub search {
	if($down_view eq "yes"){
		$down_col="<td width=30 align=center><font size=-1 color=$cel_color1>ٿ</font></td>";
	}
	opendir(SEAR, "$main_dir");
	@num_data = readdir(SEAR);
	$fil_data = @num_data-4;
	closedir(SEAR);
            
	$cou = 0;
	#@remain = "";
	foreach $list_data (@num_data) {
		if(($list_data ne "notice.txt") && ($list_data ne "conf.txt") && ($list_data ne ".") && ($list_data ne "..")) {
			open(LIST, "$main_dir/$list_data");
			@gul_data = <LIST>;
			@line1 =split(/\|/, $gul_data[1]);
			@line2 = split(/\|/,$gul_data[2]);
			close (LIST);
			
			if($FORM{'category'} eq "subject") { 
				$search_data=$line1[3];
			}
			elsif($FORM{'category'} eq "comment"){
				$search_data=$line2[1];
			}
			elsif($FORM{'category'} eq "name"){
				$search_data=$line1[0];
			}
			else{
				$category = "all";
			}
			foreach $read_line (@gul_data) {
				if($category eq "all"){
					$search_data=$read_line;
				}

				if($search_data =~ /$FORM{'keyword'}/i) { 
					$remain[$cou] = $list_data;
					$cou++;
					last;
				}
			}
		} 
	}

	$tot_pg = int($cou/$page_num);
	if(($tot_pg*$page_num) < $cou) {$tot_pg = $tot_pg + 1; }
	&head;
	@remain = sort {($b <=> $a) || ($a cmp $b)}(@remain);
	$list_num = @remain;
	if($quick1 ne ""){
		print "<script language=\"javascript\">\n";
		print "function buildArray() {\n";
		print "var a = buildArray.arguments;\n";
		print "for (i=0; i<a.length; i++) {\n";
		print "this[i] = a[i];}\n";
		print "this.length = a.length;}\n";
		print "var list1 = new buildArray(\"\",\n";
		print "\"$cgi_url?id=$quick1\",\n";
		print "\"$cgi_url?id=$quick2\",\n";
		print "\"$cgi_url?id=$quick3\",\n";
		print "\"$cgi_url?id=$quick4\",\n";
		print "\"$cgi_url?id=$quick5\",\n";
		print "\"$cgi_url?id=$quick6\",\n";
		print "\"$cgi_url?id=$quick7\");\n";
		print "function go(which, num, win) {\n";
		print "n = which.selectedIndex;\n";
		print "if (n != 0) {var url = eval(\"list\" + num + \"[n]\")\n";
		print "if (win) {openWindow(url);}\n";
		print "else{location.href = url;}}}\n";
		print "</script>\n";
		print "<div align=center><table border=0 cellpadding=2 cellspacing=0 width=$width><tr><td width=100>&nbsp;</td>\n";
		print "<td align=center><font size=-1><b>˻</b> <font color=red>$FORM{'keyword'}</font>&nbsp;&nbsp;&nbsp; <b>˻</b> <font color=red>$cou</font></font></td>\n";
		print "<td width=100 align=right><select name=quick_sel onChange=\"go(this, 1, false)\">\n";
		print "<option>ٷΰ</option>\n";
		print "<option value=$quick1>$q_name1</option>\n";
		if ($quick2 ne""){print "<option value=$quick2>$q_name2</option>\n";}
		if($quick3 ne ""){print "<option value=$quick3>$q_name3</option>\n";}
		if ($quick4 ne ""){print "<option value=$quick4>$q_name4</option>\n";}
		if ($quick5 ne ""){print "<option value=$quick5>$q_name5</option>\n";}
		if ($quick6 ne ""){print "<option value=$quick6>$q_name6</option>\n";}
		if ($quick7 ne ""){print "<option value=$quick7>$q_name7</option>\n";}
		print "</select>\n";
		print "</td></tr></table></div>\n";
	}
	else{
		print "<center><font size=-1><b>˻</b> <font color=red>$FORM{'keyword'}</font>&nbsp;&nbsp;&nbsp; <b>˻</b> <font color=red>$cou</font></font></center>\n";
	}
	if($page ==1) {
		$d = 0;
		$s = 0;
		print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=#000000 width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
		if($tot_pg <= 1) {
			print "<table width=$width cellspacing=0 cellpadding=1 border=0><tr><td width=160 align=left><a href=$cgi_url?id=$FORM{'id'}&action=form><img src=$img_url/write.gif border=0 alt=\" \"></a></td><td align=center><font size=1>Total <font color=red>$cou</font>articles [ <font color=green>$page</font>/<font color=blue>$tot_pg</font> page ]</font></td><td width=160 align=right><img src=$img_url/prev.gif border=0 alt=\" \"><img src=$img_url/next.gif border=0 alt=\" \"></td></tr></table>\n";
		}
		else {
			print "<table width=$width cellspacing=0 cellpadding=1 border=0><tr><td width=160 align=left><a href=$cgi_url?id=$FORM{'id'}&action=form><img src=$img_url/write.gif border=0 alt=\" \"></a></td><td align=center><font size=1>Total <font color=red>$cou</font>articles [ <font color=green>$page</font>/<font color=blue>$tot_pg</font> page ]</font></td><td width=160 align=right><img src=$img_url/prev.gif border=0 alt=\" \"><a href=$cgi_url?action=$FORM{'action'}&id=$FORM{'id'}&category=$FORM{'category'}&keyword=$FORM{'keyword'}&page=2><img src=$img_url/next.gif border=0 alt=\" \"></a></td></tr></table>\n";
		}
		print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=#000000 width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
		if($kind_view ne "yes"){
			$up_td = "";
		}
		else{
			$up_td = "<td>&nbsp;</td>";
		}		print "<table width=$width border=0 cellpadding=$line_length cellspacing=0 bgcolor=$head_color><tr align=center><td width=13 align=left><font color=$cel_color1></font></td>$up_td<td align=center><font size=-1 color=$cel_color1>  </font></td><td align=center><font size=-1 color=$cel_color1>ۼ</font></td><td align=center width=100><font size=-1 color=$cel_color1>ۼϽ</font></td><td width=30 align=center><font size=-1 color=$cel_color1>ȸ</font></td>$down_col</tr>\n";

		if($cou >= 1) {
			foreach $num (@remain) {
				open(FILE,"<$main_dir/$num");
				@data = <FILE>;
				close (FILE);
#-------------------------------------- [   ]---------------------------
			@down_data = split(/\|/,$data[5]);
			$file_name = "$down_data[5]";
			if($down_data[4] ne ""){
				@name_data = split(/\//,$down_data[4]);
				$n_num = @name_data - 1;
				if($name_data[$n_num] =~/\?/){
					@cgi = split(/\?/,"$name_data[$n_num]");
					$file_name = $cgi[1];
				}
				else{
					$file_name = "$name_data[$n_num]";
				}
				$f_name = "$down_data[4]";
				$file_size = "ũ";
			}
			else{
				$f_name = $file_name;
				$file_size = "$down_data[6]";
			}
			@file_type = split(/\./,$file_name);
			$type = $file_type[1];
			&file_icon;
			@unknown = split(/\./,$type);
			if($unknown[1] eq ""){
				$type = "unknown.gif";
			}
			if(($down_data[5] eq "") && ($down_data[4] eq "")) {
				$file_icon = "<img src=$img_url/type/text.gif border=0> ";
			}
			else{
				$file_icon = "<a href=\"$cgi_url?id=$FORM{'id'}&num=$num&action=down&file=$f_name\"><img src=$img_url/type/$type border=0 alt=\"$file_name($file_size) ٿޱ\"></a> ";
			}
			$down_num = $down_data[7];
			if($down_num eq ""){
				$down_num = "0";
			}
#------------------------------------------------------------------------------

				$d = ($d+1);
				$s++;
				$rotate = $d%2;
				if($rotate eq "0"){
					$tr_color=$cel_color2;
				}
				else{
					$tr_color=$cel_color1;
				}

				@list = split(/\|/, $data[1]);
			if($NT eq  "1"){
				if($list[1]) { 
					$mailto = "<a href=mailto:$list[1]>$list[0]</a>";
				}
				else {
					$mailto = $list[0];
				}   
			}
			else{
				if($list[1]) { 
					$mailto = "<a href=\"javascript:newin(350, 250, 'sendmail.cgi?name=$list[0]&mail=$list[1]&prog=$sendmail&home_url=$home_url','spmail')\">$list[0]</a>";
				}
				else {
					$mailto = $list[0];
				}   	
			}   
				$gul_len = length($list[3]);
				if($gul_len > $sub_length){
					$list[3] = substr($list[3],0,$sub_length);
					$list[3] = $list[3]."...";
				}
				$rdate = substr($list[4],5,13);
				$old_date = substr($list[4],0,10);
				&getdate;
				$new_date = substr($date,0,10);
				
				if($old_date eq $new_date) {
					if($num =~/-/){
						$subject = "<img src=$img_url/newans.gif border=0>";	
					}
					else{
						$subject = "<img src=$img_url/newgul.gif border=0>";
					}
				} 
				else{ 
					if($num =~/-/){
						$subject = "<img src=$img_url/ans.gif border=0>";
					}
					else{
						$subject = "<img src=$img_url/gul.gif border=0>";
					}
				}       
				@push = split(/-/,$num);
				shift(@push);
				$x_num = @push;
#=================================[  üũ ]===================================================
				$gul_len = length($list[3]);
				if($gul_len > $sub_length){
					for( $k = 0; $k < $sub_length; ){
						if( ord(substr($list[3], $k, 1)) >= 128 ){
							$k+=2;
						}
						else{
							$k++;
						}
						last  if( $k >= $sub_length-$x_num*3 );
					}
					$list[3] = substr($list[3],0,($k));
					$list[3] = $list[3]."..."; 
				}
#======================================================================================================
				if($kind_view ne "yes"){
					$icon_td = "";
				}
				else{
					$icon_td = "<td width=16 align=center>$file_icon</td>";
				}
				$x_num *=17;
				if($down_view eq "yes"){
					$num_col = "<td align=center><font size=-1 color=blue><b>$down_num</b></font></td>";
				}
				print "<tr bgcolor=$tr_color><td><font color=$num_color size=-1>$list_num</td>$icon_td<td><img src=$img_url/zero.gif height=10 width=$x_num><a href=$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}&action=view&number=$num&category=$FORM{'category'}&keyword=$FORM{'keyword'}>$subject $list[3]</a></font></td><td align=center><font size=-1>$mailto</font></td><td align=center width=100><font size=-1 color=$date_color>$rdate</font></td><td align=center><font size=-1 color=$read_color>$list[5]</font></td>$num_col</tr>\n";
				$list_num--;
				if($d >= $page_num) { $page=1; last;  }
			 }
         }
         else {
			if($down_view eq "yes"){
				$zero_col = "colspan=7";
			}
			else{
				$zero_col = "colspan=6";
			}
			print "<tr bgcolor=$cel_color1><td align=center $zero_col><font size=-1 color=red><b>ãô  !</b></font></td></tr>\n";
        }
    }
	if($page != 1 ) {
		$scount = (($FORM{'page'}-1)*$page_num);
		$icount = 0;
		$d = 0; 
		$pre_pg= $FORM{'page'} - 1;
		$next_pg = $FORM{'page'} + 1;
		print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=#000000 width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
		if($next_pg <= $tot_pg) {
			print "<table width=$width cellspacing=0 cellpadding=1 border=0><tr><td width=160 align=left><a href=$cgi_url?id=$FORM{'id'}&action=form><img src=$img_url/write.gif border=0 alt=\" \"></a></td><td align=center><font size=1>Total <font color=red>$cou</font>articles [ <font color=green>$page</font>/<font color=blue>$tot_pg</font> page ]</font></td><td width=160 align=right><a href=$cgi_url?action=$FORM{'action'}&id=$FORM{'id'}&category=$FORM{'category'}&keyword=$FORM{'keyword'}&page=$pre_pg><img src=$img_url/prev.gif border=0 alt=\" \"></a><a href=$cgi_url?action=$FORM{'action'}&id=$FORM{'id'}&category=$FORM{'category'}&keyword=$FORM{'keyword'}&page=$next_pg><img src=$img_url/next.gif border=0 alt=\" \"></a></td></tr></table>\n";
		}
		else {
			print "<table width=$width cellspacing=0 cellpadding=1 border=0 ><tr><td width=160 align=left><a href=$cgi_url?id=$FORM{'id'}&action=form><img src=$img_url/write.gif border=0 alt=\" \"></a></td><td align=center><font size=1>Total <font color=red>$cou</font>articles [ <font color=green>$page</font>/<font color=blue>$tot_pg</font> page ]</font></td><td width=160 align=right><a href=$cgi_url?action=$FORM{'action'}&id=$FORM{'id'}&category=$FORM{'category'}&keyword=$FORM{'keyword'}&page=$pre_pg><img src=$img_url/prev.gif border=0 alt=\" \"></a><img src=$img_url/next.gif border=0 alt=\" \"></td></tr></table>\n";
		}
		print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=#000000 width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
				if($kind_view ne "yes"){
					$up_td = "";
				}
				else{
					$up_td = "<td>&nbsp;</td>";
				}
		print "<table width=$width border=0 cellpadding=$line_length cellspacing=0 bgcolor=$head_color><tr align=center><td width=13 align=left><font color=$cel_color1></font></td>$up_td<td align=center><font size=-1 color=$cel_color1>  </font></td><td align=center><font size=-1 color=$cel_color1>ۼ</font></td><td align=center width=100><font size=-1 color=$cel_color1>ۼϽ</font></td><td width=30 align=center><font size=-1 color=$cel_color1>ȸ</font></td>$down_col</tr>\n";

		foreach $num (@remain) {
			$icount = $icount + 1;
			if($icount > $scount) {
				open(FILE,"<$main_dir/$num");
				@data = <FILE>;
				close (FILE);
#-------------------------------------- [   ]---------------------------
			@down_data = split(/\|/,$data[5]);
			$file_name = "$down_data[5]";
			if($down_data[4] ne ""){
				@name_data = split(/\//,$down_data[4]);
				$n_num = @name_data - 1;
				if($name_data[$n_num] =~/\?/){
					@cgi = split(/\?/,"$name_data[$n_num]");
					$file_name = $cgi[1];
				}
				else{
					$file_name = "$name_data[$n_num]";
				}
				$f_name = "$down_data[4]";
				$file_size = "ũ";
			}
			else{
				$f_name = $file_name;
				$file_size = "$down_data[6]";
			}
			@file_type = split(/\./,$file_name);
			$type = $file_type[1];
			&file_icon;
			@unknown = split(/\./,$type);
			if($unknown[1] eq ""){
				$type = "unknown.gif";
			}
			if(($down_data[5] eq "") && ($down_data[4] eq "")) {
				$file_icon = "<img src=$img_url/type/text.gif border=0>";
			}
			else{
				$file_icon = "<a href=\"$cgi_url?id=$FORM{'id'}&num=$num&action=down&file=$f_name\"><img src=$img_url/type/$type border=0 alt=\"$file_name($file_size) ٿޱ\"></a>";
			}
			$down_num = $down_data[7];
			if($down_num eq ""){
				$down_num = "0";
			}
#------------------------------------------------------------------------------

				$d = ($d+1);
				$s=$scount+$d;
				$rotate = $d%2;
				if($rotate eq "0"){
					$tr_color=$cel_color2;
				}
				else{
					$tr_color=$cel_color1;
				}
				@list = split(/\|/, $data[1]);
			if($NT eq  "1"){
				if($list[1]) { 
					$mailto = "<a href=mailto:$list[1]>$list[0]</a>";
				}
				else {
					$mailto = $list[0];
				}   
			}
			else{
				if($list[1]) { 
					$mailto = "<a href=\"javascript:newin(350, 250, 'sendmail.cgi?name=$list[0]&mail=$list[1]&prog=$sendmail&home_url=$home_url','spmail')\">$list[0]</a>";
				}
				else {
					$mailto = $list[0];
				}   	
			}  
				$gul_len = length($list[3]);
				if($gul_len > $sub_length){
					$list[3] = substr($list[3],0,$sub_length);
					$list[3] = $list[3]."...";
				}
				$rdate=substr($list[4],5,13);
				$old_date = substr($list[4],0,10);
				&getdate;
				$new_date = substr($date,0,10);
				if($old_date eq $new_date) {
					if($num =~/-/){
						$subject = "<img src=$img_url/newans.gif border=0>";	
					}
					else{
						$subject = "<img src=$img_url/newgul.gif border=0>";
					}
				} 
				else{ 
					if($num =~/-/){
						$subject = "<img src=$img_url/ans.gif border=0>";
					}
					else{
						$subject = "<img src=$img_url/gul.gif border=0>";
					}
				}    
				@push = split(/-/,$num);
				shift(@push);
				$x_num = @push;
#=================================[  üũ ]===================================================
				$gul_len = length($list[3]);
				if($gul_len > $sub_length){
					for( $k = 0; $k < $sub_length; ){
						if( ord(substr($list[3], $k, 1)) >= 128 ){
							$k+=2;
						}
						else{
							$k++;
						}
						last  if( $k >= $sub_length-$x_num*3 );
					}
					$list[3] = substr($list[3],0,($k));
					$list[3] = $list[3]."..."; 
				}
#======================================================================================================
				if($kind_view ne "yes"){
					$icon_td = "";
				}
				else{
					$icon_td = "<td width=16 align=center>$file_icon</td>";
				}
				$x_num *=17;
				if($down_view eq "yes"){
					$num_col = "<td align=center><font size=-1 color=blue><b>$down_num</b></font></td>";
				}
				print "<tr bgcolor=$tr_color><td><font color=$num_color size=-1>$list_num</td>$icon_td<td><img src=$img_url/zero.gif height=10 width=$x_num><a href=$cgi_url?id=$FORM{'id'}&page=$page&action=view&number=$num&category=$FORM{'category'}&keyword=$FORM{'keyword'}>$subject $list[3]</a></font></td><td align=center><font size=-1>$mailto</font></td><td align=center width=100><font size=-1 color=$date_color>$rdate</font></td><td align=center><font size=-1 color=$read_color>$list[5]</font></td>$num_col</tr>\n";
			}
			$list_num--;
			if($d >= $page_num) { $page= $FORM{'page'}; last;}
		 }
	}
	print "</table></td></tr></table><br>";
	&pagemove;
	print "<br><center><a href=$cgi_url?id=$FORM{'id'}><img src=$img_url/backtolist.gif border=0 alt=\"۸ \"></a></center>\n";
	&find;
	&foot;
}

sub find {
	print "<form method=post action=$cgi_url>\n";
	print "<table><tr><td><input type=hidden name=action value=search><input type=hidden name=id value=$FORM{'id'}>\n";
    print "<select name=category>\n";
    print "<option value=all> ü</option>\n";
    print "<option value=name> </option>\n";
    print "<option value=subject> </option>\n";
    print "<option value=comment> </option>\n";
    print "</select></td>\n";
 	print "<td><input type=text name=keyword size=15 style=\"background-color:#FFFFFF;height:21px;border:1 solid black\"></td>\n";
	print "<td><input type=image src=$img_url/search_button.gif border=0></td>\n";
	print "</form></tr></table>\n";
}

sub erase {
	&head;
print <<START;
<h3>йȣ ԷϽÿ.</h3>
<table><tr><td><ul>
<li> <font color=red><b>$FORM{'subject'}</b></font> մϴ.
<li>ѹ   ٽ   ϴ.
<li>̱ 亯 ۱  ˴ϴ</ul></td></tr></table>
<form method=post action=$cgi_url>
<input type=hidden name=action value=eraseok>
<input type=hidden name=page value=$FORM{'page'}>
<input type=hidden name=id value=$FORM{'id'}>
<input type=hidden name=number value=$FORM{'number'}>
<table><tr><td>йȣ</td><td><input type=password name=passwd size=10 style="background-color:#ffffff;border:1 solid $head_color"></td><td><input type=submit value= style="background-color:$cel_color1;border:1 solid $head_color;height:20"></td><td></form></td></tr></table>
START
	&foot;
}

sub eraseok {
	$pass = crypt($FORM{'passwd'},sp);
	open(FILE,"<$main_dir/$FORM{'number'}");
	@filea = <FILE>;
	@seper = split(/\|/,$filea[5]);
	close (FILE);
	unlink ("$main_dir/files/$seper[5]");
	chop($filea[0]);
	if(($filea[0] eq $pass) || ($admin eq $pass)) {
		$num = $FORM{'number'};
		if($filea[3] > 0) {
			&auto_erase;
		}
		unlink("$main_dir/$FORM{'number'}");
		&load_page;
	}
	else {
		$err = pass;
		&error;
	}
}

sub admin_remove_ok {
	unlink("$main_dir/notice.txt");
	&load_page;
}

sub auto_erase{
	&gul_list;
	$same_num=length($FORM{'number'})+1;
	for($i=0; $i<$list_num; $i++){
		$find_same=substr($remain[$i],0,$same_num);
		if("$FORM{'number'}-" eq $find_same){
			open(FILE,"<$main_dir/$remain[$i]");
			@ldata = <FILE>;
			@file_data = split(/\|/,$ldata[5]);
			close (FILE);
			unlink "$main_dir/$remain[$i]";
			unlink "$main_dir/files/$file_data[5]"
		}
	}
}

sub pagemove{
	print "<div align=center><table><tr><td align=center>";

	$term = 10;
	$first = 1;
	$last = $term;
	while ($first <= $tot_pg) {
		if (($first <= $page) && ($page <= $last)) {
		$prevp = $first - 1;
			if ($prevp > 0) {
				if ($FORM{'action'} eq "search") {
					print "[<a href=$cgi_url?action=search&category=$FORM{'category'}&id=$FORM{'id'}&page=$prevp&keyword=$FORM{'keyword'} onmouseover=\"window.status='  ';return true\" onmouseout=\"window.status='';return true\"></a>].....";
				}
				else{
					print "[<a href=$cgi_url?id=$FORM{'id'}&page=$prevp onmouseover=\"window.status='  ';return true\" onmouseout=\"window.status='';return true\"></a>].....";
				}
			}
			else {
				print "[<font color=C0C0C0></font>].....";
			}
		if ($last <= $tot_pg) {
			for ($pa = $first; $pa <= $last; $pa++) {
				if ($pa == $page) {
					print "[<font color=red><b>$pa</b></font>] ";
				}
				else {
					if($FORM{'action'} eq "search") {
						print "[<a href=$cgi_url?action=search&category=$FORM{'category'}&id=$FORM{'id'}&page=$pa&keyword=$FORM{'keyword'} onmouseover=\"window.status='$pa  ̵';return true\" onmouseout=\"window.status='';return true\">$pa</a>] ";
					}
					else{
						print "[<a href=$cgi_url?id=$FORM{'id'}&page=$pa onmouseover=\"window.status='$pa  ̵';return true\" onmouseout=\"window.status='';return true\">$pa</a>] ";
					}
				}
			}
		}
		else {
			for ($pa = $first; $pa <= $tot_pg; $pa++) {
				if ($pa == $page) {
					print "[<font color=red><b>$pa</b></font>] ";
				}
				else {
					if($FORM{'action'} eq "search"){
						print "[<a href=$cgi_url?action=search&category=$FORM{'category'}&id=$FORM{'id'}&page=$pa&keyword=$FORM{'keyword'} onmouseover=\"window.status='$pa  ̵';return true\" onmouseout=\"window.status='';return true\">$pa</a>]  ";
					}
					else{
						print "[<a href=$cgi_url?id=$FORM{'id'}&page=$pa onmouseover=\"window.status='$pa  ̵';return true\" onmouseout=\"window.status='';return true\">$pa</a>]  ";
					}
				}
			}
		}
		$nextp = $last + 1;
		if ($nextp <= $tot_pg) {
			if($FORM{'action'} eq "search") {
				print ".....[<a href=$cgi_url?action=search&category=$FORM{'category'}&id=$FORM{'id'}&page=$nextp&keyword=$FORM{'keyword'} onmouseover=\"window.status='  ';return true\" onmouseout=\"window.status='';return true\"></a>]";
			}
			else{
				print ".....[<a href=$cgi_url?id=$FORM{'id'}&page=$nextp onmouseover=\"window.status='  ';return true\" onmouseout=\"window.status='';return true\"></a>]";
			}
		}
		else {
			print ".....[<font color=C0C0C0></font>]";
		}
	}
	$first = $first + $term;
	$last = $last + $term;
	}
	print "</td></tr></table></div>";
}

sub loginok {
			$pass = crypt($FORM{'passwd'},sp);

	if($admin eq $pass) {
		&head;
print <<START;
<p>&nbsp;
<p>&nbsp;
  Ͽϴ.<p>
ϴ ׸ Ͻð "LET'S GO!!!"ư ּ!
<form method=post action=$cgi_url> 
<input type=hidden name=id value=$FORM{'id'}>
<input type=hidden name=action value=admin_act>
<input type=hidden name=passwd value=$pass>
<select name=admin_select>
<option value="admin_conf" selected>Խ ȯ漳
<option value="notice_form"> </select>
<input type=submit value=" LET'S GO!!! " style="background-color:$cel_color1;border:1 solid $head_color;height:20">
</form>
<p>&nbsp;
<p>&nbsp;
START
		&foot;
	}
	else {
		$err = pass;
		&error;
	}
}

sub admin_conf {
	if($FORM{'passwd'} eq $admin){ 
		if($admin_only eq "yes"){
			$only_yes = "selected";
			$only_no = "";
		}
		else{
			$only_yes = "";
			$only_no = "selected";
		}
		if($view_ip eq "yes"){
			$ip_yes = "selected";
			$ip_no = "";
		}
		else{
			$ip_yes = "";
			$ip_no = "selected";
		}
		if($pds_ok eq "yes"){
			$pds_yes = "selected";
			$pds_no = "";
		}
		else{
			$pds_yes = "";
			$pds_no = "selected";
		}
		if($down_view eq "yes"){
			$dv_yes = "selected";
			$dv_no = "";
		}
		else{
			$dv_yes = "";
			$dv_no = "selected";
		}
		if($kind_view eq "yes"){
			$kv_yes = "selected";
			$kv_no = "";
		}
		else{
			$kv_yes = "";
			$kv_no = "selected";
		}
		if($smail eq "yes"){
			$smail_yes = "selected";
			$smail_no = "";
		}
		else{
			$smail_yes = "";
			$smail_no = "selected";
		}
		&head;
print <<START;
<form method=post action=$cgi_url>
<input type=hidden name=id value=$FORM{'id'}>
<input type=hidden name=action value=make_conf>
<input type=hidden name=passwd value=$FORM{'passwd'}>
<div align=center>
<table cellspacing=0 cellpadding=1 border=0 width=500 bgcolor=$head_color>
<tr><td align=center><b><font color=$cel_color1>ȯ </font></b></td></tr>
<tr><td>
<table cellspacing=0 cellpadding=1 border=0 width=100%>
<tr bgcolor=#FFF3EF><td align=right>[йȣ : ĭ ״ νø  йȣ ]
<br>йȣ <input type=password name=pass size=10> ٽȮ <input type=password name=pass_eq size=10></td></tr>
<tr bgcolor=#FFF3EF><td align=right> ڸ ۾ 
<select name=admin_only>
<option value="yes" $only_yes>YES
<option value="no" $only_no>NO</select></td></tr>
<tr bgcolor=#FFF3EF><td align=right> IP  
<select name=view_ip>
<option value="yes" $ip_yes>YES
<option value="no" $ip_no>NO</select></td></tr>
<tr bgcolor=#F6FDFF><td align=right> ڷǷ ϱ 
<select name=pds_ok>
<option value="yes" $pds_yes>YES
<option value="no" $pds_no>NO</select></td></tr>
<tr bgcolor=#F6FDFF><td align=right> Ÿ ̱ 
<select name=kind_view>
<option value="yes" $kv_yes>YES
<option value="no" $kv_no>NO</select></td></tr>
<tr bgcolor=#F6FDFF><td align=right> ٿ ̱ 
<select name=down_view>
<option value="yes" $dv_yes>YES
<option value="no" $dv_no>NO</select></td></tr>
<tr bgcolor=#F6FDFF><td align=right>ϴ ø ִ ִ 뷮(MB) <input type=text name=max_size size=10  maxlength=3 value="$max_size"></td></tr>
<tr bgcolor=#FDEDFF><td align=right> Ÿ   <input type=text name=page_num size=10  maxlength=3 value="$page_num"></td></tr>
<tr bgcolor=#FDEDFF><td align=right>Ÿ ִ   <input type=text name=max_data size=10  value="$max_data"></td></tr>
<tr bgcolor=#FDEDFF><td align=right> ִ<input type=text name=sub_length size=10  value="$sub_length"></td></tr>
<tr bgcolor=#FDEDFF><td align=right>Խ  <input type=text name=width size=10  maxlength=3 value="$width"></td></tr>
<tr bgcolor=#FDEDFF><td align=right> <input type=text name=line_length size=10  maxlength=3 value="$line_length"></td></tr>
<tr bgcolor=#FCFFE7><td align=right> ̸ <input type=text name=admin_name size=10 value=$admin_name></td></tr>
<tr bgcolor=#FCFFE7><td align=right>Ȩ URL <input type=text name=home_url size=40 value=$home_url></td></tr>
<tr bgcolor=#FCFFE7><td align=right> ̸ ּ <input type=text name=admin_mail size=20 value="$admin_mail"></td></tr>
<tr bgcolor=#FCFFE7><td align=right>亯Ͻ Ϸ ˸ 
<select name=admin_select>
<option value="yes" $smail_yes>YES
<option value="no" $smail_no>NO</select></td></tr>
<tr bgcolor=#EDFFF0><td align=right> <input type=text name=bgcolor size=8 value=$bgcolor>
or  ̹ URL <input type=text name=background size=25 value=$background></td></tr>
<tr bgcolor=#EDFFF0><td align=right>  <input type=text name=ncel_color size=10 value=$ncel_color></td></tr>
<tr bgcolor=#EDFFF0><td align=right> (ѻ) <input type=text name=head_color size=10 value=$head_color></td></tr>
<tr bgcolor=#EDFFF0><td align=right> 1(ѻ) <input type=text name=cel_color1 size=10 value=$cel_color1></td></tr>
<tr bgcolor=#EDFFF0><td align=right> 2(ѻ) <input type=text name=cel_color2 size=10 value=$cel_color2></td></tr>
<tr bgcolor=#EDFFF0><td align=right>а ִ  ǥû <input type=text name=select_color size=10 value=$select_color></td></tr>
<tr bgcolor=#EDFFF0><td align=right> ǥû <input type=text name=num_color size=10 value=$num_color></td></tr>
<tr bgcolor=#EDFFF0><td align=right>¥ ǥû <input type=text name=date_color size=10 value=$date_color></td></tr>
<tr bgcolor=#EDFFF0><td align=right> ǥû <input type=text name=read_color size=10 value=$read_color></td></tr>
<tr bgcolor=#EFFBFF><td align=right>logo ̹ URL <input type=text name=logo_img size=43 value=$logo_img></td></tr>
<tr bgcolor=#EFFBFF><td align=right>ؽƮ ΰ <input type=text name=logo_txt size=43 value="$logo_txt"></td></tr>
<tr bgcolor=#EFFBFF><td align=right>1. ID <input type=text name=quick1 size=17 value="$quick1"> NAME <input type=text name=q_name1 size=17 value="$q_name1"></td></tr>
<tr bgcolor=#EFFBFF><td align=right>2. ID <input type=text name=quick2 size=17 value="$quick2"> NAME <input type=text name=q_name2 size=17 value="$q_name2"></td></tr>
<tr bgcolor=#EFFBFF><td align=right>3. ID <input type=text name=quick3 size=17 value="$quick3"> NAME <input type=text name=q_name3 size=17 value="$q_name3"></td></tr>
<tr bgcolor=#EFFBFF><td align=right>4. ID <input type=text name=quick4 size=17 value="$quick4"> NAME <input type=text name=q_name4 size=17 value="$q_name4"></td></tr>
<tr bgcolor=#EFFBFF><td align=right>5. ID <input type=text name=quick5 size=17 value="$quick5"> NAME <input type=text name=q_name5 size=17 value="$q_name5"></td></tr>
<tr bgcolor=#EFFBFF><td align=right>6. ID <input type=text name=quick6 size=17 value="$quick6"> NAME <input type=text name=q_name6 size=17 value="$q_name6"></td></tr>
<tr bgcolor=#EFFBFF><td align=right>7. ID <input type=text name=quick7 size=17 value="$quick7"> NAME <input type=text name=q_name7 size=17 value="$q_name7"></td></tr>
</table>
</td></tr>
</table>
</div>
<br>
<input type=submit value=ϱ style="background-color:$cel_color1;border:1 solid $head_color;height:20"> 
<input type=reset value=ٽþ style="background-color:$cel_color1;border:1 solid $head_color;height:20">
</form>

START
		&foot;
	}
	else{
		$err=pass;
		&error;
	}
}

sub make_conf{
	if($FORM{'passwd'} eq $admin){ 
		if($FORM{'pass'} eq ""){
			$passwd = $admin;
		}
		elsif($FORM{'pass'} eq $FORM{'pass_eq'}){
		
			$pass = crypt($FORM{'pass'},sp);
			
			$passwd = $pass;	
		}
		else{
			$err=pass;
			&error;
		}
		
		open(SAVE,">$main_dir/conf.txt");
		print SAVE "|$FORM{'page_num'}|$FORM{'admin_only'}|$FORM{'max_data'}|$passwd|$FORM{'admin_select'}|$FORM{'admin_mail'}|$FORM{'home_url'}|$FORM{'width'}|$FORM{'admin_name'}|$FORM{'ncel_color'}|$FORM{'head_color'}|$FORM{'cel_color1'}|$FORM{'select_color'}|$FORM{'num_color'}|$FORM{'date_color'}|$FORM{'read_color'}|$FORM{'bgcolor'}|$FORM{'background'}|$FORM{'logo_img'}|$FORM{'logo_txt'}|$FORM{'sub_length'}|$FORM{'cel_color2'}|$FORM{'line_length'}|$FORM{'view_ip'}|$FORM{'pds_ok'}|$FORM{'max_size'}|$FORM{'down_view'}|$FORM{'kind_view'}|\n";
		print SAVE "|$FORM{'quick1'}|$FORM{'quick2'}|$FORM{'quick3'}|$FORM{'quick4'}|$FORM{'quick5'}|$FORM{'quick6'}|$FORM{'quick7'}|\n";
		print SAVE "|$FORM{'q_name1'}|$FORM{'q_name2'}|$FORM{'q_name3'}|$FORM{'q_name4'}|$FORM{'q_name5'}|$FORM{'q_name6'}|$FORM{'q_name7'}|\n";
		close(SAVE);

		open(CONF,"<$main_dir/conf.txt");
		@list = <CONF>;
		close(CONF);
		@env = split(/\|/,$list[0]);
		@quick = split(/\|/,$list[1]);
		@q_name = split(/\|/,$list[2]);
        $page_num = $env[1];
		$admin_only = $env[2];
	    $max_data = $env[3];
		$admin = $env[4];
        $smail = $env[5];
	    $admin_mail = $env[6];
		$home_url = $env[7];
        $width = $env[8];
	    $admin_name = $env[9];
		$ncel_color = $env[10];
        $head_color = $env[11];
		$cel_color1 = $env[12];
		$select_color = $env[13];
        $num_color = $env[14];
	    $date_color = $env[15];
		$read_color = $env[16];
		$bgcolor = $env[17];
		$background = $env[18];
		$logo_img = $env[19];
		$logo_txt = $env[20];
		$sub_length = $env[21];
		$cel_color2 = $env[22];
		$line_length = $env[23];
		$view_ip = $env[24];
		$pds_ok = $env[25];
		$max_size = $env[26];
		$down_view = $env[27];
		$kind_view = $env[28];
		$quick1 = $quick[1];
		$quick2 = $quick[2];
		$quick3 = $quick[3];
		$quick4 = $quick[4];
		$quick5 = $quick[5];
		$quick6 = $quick[6];
		$quick7 = $quick[7];
		$q_name1 = $q_name[1];
		$q_name2 = $q_name[2];
		$q_name3 = $q_name[3];
		$q_name4 = $q_name[4];
		$q_name5 = $q_name[5];
		$q_name6 = $q_name[6];
		$q_name7 = $q_name[7];

		&load_page;
	}
	else{
		$err=pass;
		&error;
	}
}

sub view_notice{
	open(VFILE, "<$main_dir/notice.txt");
	@views = <VFILE>;
	close(VFILE);	
	@notice = split(/\|/,$views[0]);
	$html = $notice[0];
	$subject = $notice[1];
	$comments = $notice[2];
	$rdate=substr($notice[3],0,18);
	$plus_num = $notice[5]+1;
	$auto_link = $views[1];
	&lock;
	open(NFI,">$main_dir/notice.txt");
	print NFI "$html|$subject|$comments|$notice[3]|$notice[4]|$plus_num|\n";
	print NFI "$auto_link\n";
	close(NFI);
	&unlock;
	chop($auto_link);
	if ($html ne "1") { 
        $comments =~ s/<br>/\r\n/g;
	    $comments =~ s/<p>/\r\n\r\n/g;
	    $comments =~ s/</&lt;/g;
        $comments =~ s/>/&gt;/g;
        $comments =~ s/"/&quot;/g;
        $comments =~ s/\|/&#124;/g;
	    $comments =~ s/&lt;hr&gt;/<hr>/g;
	}
	$comments =~ s/\r\n\r\n/<p>/g;
    $comments =~ s/\r\n/<br>/g;
    $comments =~ s/\|/&#124;/g;
	if($auto_link eq "1"){
		$comments =~ s/(http:\/\/)([\w\+\-\/\=\?\.\~]+)/$url <img src=$img_url\/home.gif> <a href=\"$1$2\" target=\"_new\">$1$2<\/a>/g;
		$comments =~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/$mail <img src=$img_url\/mail.gif> <a href=\"mailto:$1\">$1<\/a>/g;
	}
	&head;
print <<START;
<p>
<div align=center>
<table border=0 cellpadding=1 cellspacing=0 width=$width>
    <tr>
	<td colspan=2>ۼ - <font color=$date_color>$rdate</font></td>
	</tr>
	<tr bgcolor=$head_color>
        <td>
		<table width=100% border=0 cellpadding=2 cellspacing=0>
		<tr>
		<td>
		<font color=$cel_color1 size=-1> <b>$subject</font></b></td>
		<td align=right><font color=$cel_color1>ȸ [ <b>$plus_num</b> ]</font>
			<a href=$cgi_url?id=$FORM{'id'}&action=admin_modify><img src=$img_url/modify.gif border=0 alt="ϱ"></a>
			<a href=$cgi_url?id=$FORM{'id'}&action=admin_remove><img src=$img_url/remove.gif border=0 alt="ϱ"></a> &nbsp;
		</tr>
		</table>		
	</td>
    </tr>
    <tr  bgcolor=$head_color>
        <td colspan=2>
			<table border=0 cellpadding=3 cellspacing=0 width=100% bgcolor=$cel_color1>
                <tr>
                    <td height=220 valign=top class=cont><p class=t>$comments</p></td>
                </tr>
            </table></td>
    </tr>
</table></div>
<p>
<a href=$cgi_url?id=$FORM{'id'}><img src=$img_url/backtolist.gif border=0 alt=" "></a>
START
	&foot;
}

sub lock {
    local($LockFile) = "$main_dir/lock.txt";
    local($EndTime) = time+45;
    
    while (-s $LockFile && time < $EndTime) {
    	sleep(1);
    }
    open(LOCK, ">$main_dir/$LockFile");
    print LOCK "lock";
    close(LOCK);
}

sub unlock {
    local($LockFile) = "$main_dir/lock.txt";
    
    open(LOCK, ">$main_dir/$LockFile");
    print LOCK "";
    close(LOCK);
}

sub sendmail {
		open (MAIL, "|$sendmail -t $addr");
		print MAIL "Reply-to: $admin_mail\n";
		print MAIL "From: $admin_name<$admin_mail>\n";
		print MAIL "Subject: 亯 ϵǾϴ.\n\n";
       	print MAIL "\n\n$FORM{'name'}Բ  ۿ 亯 Ͽϴ.\n";
       	print MAIL "Ʒ Ȩ 湮Ͻþ ȮϽñ ٶϴ.\n\n";
    	print MAIL "ߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡ\n";
    	print MAIL "\t This message form $home_url\n";
    	print MAIL "ߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡ\n\n";
		close (MAIL);
}

EOF